#line 1 "C:/Users/George/Work/PIC Programming/Voodoo V1.1/Voodoo_V1.c"
#line 37 "C:/Users/George/Work/PIC Programming/Voodoo V1.1/Voodoo_V1.c"
sbit LCD_D4 at RB3_bit;
sbit LCD_D5 at RB2_bit;
sbit LCD_D6 at RB1_bit;
sbit LCD_D7 at RB0_bit;
sbit LCD_RS at RB5_bit;
sbit LCD_EN at RB4_bit;


sbit LCD_RS_Direction at TRISB5_bit;
sbit LCD_EN_Direction at TRISB4_bit;
sbit LCD_D7_Direction at TRISB0_bit;
sbit LCD_D6_Direction at TRISB1_bit;
sbit LCD_D5_Direction at TRISB2_bit;
sbit LCD_D4_Direction at TRISB3_bit;


sbit debug at LATD2_bit;
sbit EN1 at LATD6_bit;
sbit ps_sync at LATC0_bit;
sbit main_pulse at LATC3_bit;
sbit efe_pulse at LATD0_bit;
sbit disc_pulse at LATC1_bit;
sbit audio_en at LATA4_bit;
sbit menu_btn_port at PORTC.B6;
sbit up_btn_port at PORTC.B5;
sbit down_btn_port at PORTC.B4;
sbit enter_btn_port at PORTD.B3;
#line 78 "C:/Users/George/Work/PIC Programming/Voodoo V1.1/Voodoo_V1.c"
const debounce = 100;
const btn_off = 1;
const btn_on = 0;
const menu_btn = 1;
const up_btn = 2;
const down_btn = 3;
const enter_btn = 4;
const menu_active = 1;
const menu_inactive = 0;
const pulse = 0;
const hybrid = 1;
const blk_limit = 7;


const txon_offset = 4;
const txpd_offset = 8;
const main_dly_offset = 5;
const main_smpl_offset = 4;
const efe_dly_offset = 10;
const disc_dly_offset = 9;
const disc_smpl_offset = 6;


unsigned i;
unsigned tmp;
char int_state;
char main_state;
char hybrid_cycle;
unsigned t;
unsigned vbatt;
unsigned pi_target;
unsigned disc_target;
char loop_count;
unsigned pi_array[64];
char pi_pointer;
unsigned pi_tmp;
unsigned pi_total;
unsigned disc_array[64];
char disc_pointer;
unsigned disc_tmp;
unsigned disc_total;
unsigned short pi_adc = 0;
unsigned short disc_adc = 1;
unsigned short batt_adc = 7;
char keypad_btn;
char result;
char menu_flag;
char menu_disp;
char detect_mode;
unsigned pi_thr;
unsigned disc_thr;
char thr_disp;
char txon;
char txonh;
char txonl;
unsigned txpd;
char txpdh;
char txpdl;
char main_dly;
char main_dlyh;
char main_dlyl;
char main_smpl;
char main_smplh;
char main_smpll;
unsigned efe_dly;
char efe_dlyh;
char efe_dlyl;
char efe_smplh;
char efe_smpll;
char pi_num;
char disc_dly;
char disc_dlyh;
char disc_dlyl;
char disc_smpl;
char disc_smplh;
char disc_smpll;
char disc_num;
char accept;
char accept_blk;
char reject;
char reject_blk;
char update_disp;
char meter_zero;
char meter_zero_limit;
char counter_limit;


void interrupt() {
 switch (int_state) {
 case 0:
 EN1 =  1; ;
 TMR0H = txonh;
 TMR0L = txonl;
 TMR1H = txpdh;
 TMR1L = txpdl;
 ps_sync = 1;
 debug = 1;
 PIR1 = 0x00;
 INTCON = 0xE0;
 if (hybrid_cycle == 0) {
 int_state = 1;
 } else {
 int_state = 6;
 }
 break;
 case 1:
 EN1 =  0; ;
 TMR0H = main_dlyh;
 TMR0L = main_dlyl;
 ps_sync = 0;
 debug = 0;
 INTCON = 0xE0;
 int_state = 2;
 break;
 case 2:
 main_pulse =  0; ;
 TMR0H = main_smplh;
 TMR0L = main_smpll;
 ps_sync = 1;
 INTCON = 0xE0;
 int_state = 3;
 break;
 case 3:
 main_pulse =  1; ;
 TMR0H = efe_dlyh;
 TMR0L = efe_dlyl;
 ps_sync = 0;
 INTCON = 0xE0;
 int_state = 4;
 break;
 case 4:
 efe_pulse =  0; ;
 TMR0H = efe_smplh;
 TMR0L = efe_smpll;
 ps_sync = 1;
 INTCON = 0xE0;
 int_state = 5;
 break;
 case 5:
 efe_pulse =  1; ;
 TMR0H = 0x00;
 TMR0L = 0x00;
 ps_sync = 0;
 INTCON = 0xE0;
 if (detect_mode == pulse) {
 hybrid_cycle = 0;
 } else {
 hybrid_cycle = 1;
 }
 int_state = 0;
 break;
 case 6:
 EN1 =  0; ;
 TMR0H = disc_dlyh;
 TMR0L = disc_dlyl;
 ps_sync = 0;
 debug = 0;
 INTCON = 0xE0;
 int_state = 7;
 break;
 case 7:
 disc_pulse =  0; ;
 TMR0H = disc_smplh;
 TMR0L = disc_smpll;
 ps_sync = 1;
 INTCON = 0xE0;
 int_state = 8;
 break;
 case 8:
 disc_pulse =  1; ;
 TMR0H = 0x00;
 TMR0L = 0x00;
 ps_sync = 0;
 INTCON = 0xE0;
 hybrid_cycle = 0;
 int_state = 0;
 break;
 }
}


void extract_and_disp(
 unsigned value,
 unsigned divisor,
 char row,
 char col) {
 char ch;
 ch = value / divisor % 10;
 Lcd_Chr(row, col, 48 + ch);
}


void battery_measure() {
 t = 0;
 for (i = 1; i <= 8; i++) {
 t += ADC_Read(batt_adc);
 }
 t = t / 8;
 t = (5000 - (t * 5)) * 3 / 100;
}


void battery_display() {
 extract_and_disp(t, 100, 1, 10);
 extract_and_disp(t, 10, 1, 11);
 Lcd_Out(1, 12, ".");
 extract_and_disp(t, 1, 1, 13);
 Lcd_Out(1, 14, "V ");
}


void battery_symbol() {
 if (t >= 120)
 Lcd_Chr(1, 16, 0);
 else if (t >= 117)
 Lcd_Chr(1, 16, 1);
 else if (t >= 114)
 Lcd_Chr(1, 16, 2);
 else if (t >= 111)
 Lcd_Chr(1, 16, 3);
 else if (t >= 108)
 Lcd_Chr(1, 16, 4);
 else if (t >= 105)
 Lcd_Chr(1, 16, 5);
 else
 Lcd_Out(1, 16, "X");
}

void calc_txon() {
 tmp = 65535 - ((txon - txon_offset) / 2) * 10;
 txonh = tmp >> 8;
 txonl = tmp - (txonh << 8);
}

void calc_txpd() {
 tmp = 65535 - ((txpd - txpd_offset) / 2) * 10;
 txpdh = tmp >> 8;
 txpdl = tmp - (txpdh << 8);
}

void calc_main_dly() {
 tmp = 65535 - ((main_dly - main_dly_offset) / 2) * 10;
 main_dlyh = tmp >> 8;
 main_dlyl = tmp - (main_dlyh << 8);
}

void calc_main_smpl() {
 tmp = 65535 - ((main_smpl - main_smpl_offset) / 2) * 10;
 main_smplh = tmp >> 8;
 main_smpll = tmp - (main_smplh << 8);
}

void calc_efe_dly() {
 tmp = 65535 - ((efe_dly - efe_dly_offset) / 2) * 10;
 efe_dlyh = tmp >> 8;
 efe_dlyl = tmp - (efe_dlyh << 8);
}

void calc_efe_smpl() {
 efe_smplh = main_smplh;
 efe_smpll = main_smpll;
}

void calc_disc_dly() {
 tmp = 65535 - ((disc_dly - disc_dly_offset) / 2) * 10;
 disc_dlyh = tmp >> 8;
 disc_dlyl = tmp - (disc_dlyh << 8);
}

void calc_disc_smpl() {
 tmp = 65535 - ((disc_smpl - disc_smpl_offset) / 2) * 10;
 disc_smplh = tmp >> 8;
 disc_smpll = tmp - (disc_smplh << 8);
}

void clear_arrays() {
 for (i = 0; i <= (pi_num - 1); i++) {
 pi_array[i] = 0;
 disc_array[i] = 0;
 }
 pi_pointer = 0;
 pi_total = 0;
 disc_pointer = 0;
 disc_total = 0;
}

void write_eeprom() {
 EEPROM_Write(0, 0xAA);
 EEPROM_Write(1, detect_mode);
 tmp = pi_thr >> 8;
 EEPROM_Write(2, tmp);
 tmp = (pi_thr << 8) >> 8;
 EEPROM_Write(3, tmp);
 EEPROM_Write(4, txon);
 tmp = txpd >> 8;
 EEPROM_Write(5, tmp);
 tmp = (txpd << 8) >> 8;
 EEPROM_Write(6, tmp);
 EEPROM_Write(7, main_dly);
 EEPROM_Write(8, main_smpl);
 tmp = efe_dly >> 8;
 EEPROM_Write(9, tmp);
 tmp = (efe_dly << 8) >> 8;
 EEPROM_Write(10, tmp);
 EEPROM_Write(11, pi_num);
 tmp = disc_thr >> 8;
 EEPROM_Write(12, tmp);
 tmp = (disc_thr << 8) >> 8;
 EEPROM_Write(13, tmp);
 EEPROM_Write(14, disc_dly);
 EEPROM_Write(15, disc_smpl);
 EEPROM_Write(16, disc_num);
 EEPROM_Write(17, meter_zero_limit);
 EEPROM_Write(18, counter_limit);
}


char scan_keypad() {
 result = 0;
 if (menu_btn_port == btn_on) {
 result = menu_btn;
 Delay_ms(debounce);
 while (menu_btn_port == btn_on) {}
 Delay_ms(debounce);
 } else {
 if (up_btn_port == btn_on) {
 result = up_btn;
 Delay_ms(debounce);
 while (up_btn_port == btn_on) {}
 Delay_ms(debounce);
 } else {
 if (down_btn_port == btn_on) {
 result = down_btn;
 Delay_ms(debounce);
 while (down_btn_port == btn_on) {}
 Delay_ms(debounce);
 } else {
 if (enter_btn_port == btn_on) {
 result = enter_btn;
 Delay_ms(debounce);
 while (enter_btn_port == btn_on) {}
 Delay_ms(debounce);
 }
 }
 }
 }
 return result;
}


void menu_system() {
 PIE1 = 0x00;
 INTCON = 0x00;
 menu_flag = menu_active;
 EN1 =  0; ;
 audio_en =  0; ;
 menu_disp = 0;
 while (menu_flag == menu_active) {
 switch (menu_disp) {
 case 0:
 Lcd_Out(1, 1, " DETECTING MODE ");
 if (detect_mode == pulse) {
 Lcd_Out(2, 1, "     PULSE      ");
 } else {
 Lcd_Out(2, 1, "     HYBRID     ");
 }
 if ((keypad_btn == up_btn) || (keypad_btn == down_btn)) {
 if (detect_mode == pulse) {
 detect_mode = hybrid;
 } else {
 detect_mode = pulse;
 }
 }
 break;
 case 1:
 Lcd_Out(1, 1, "  PI THRESHOLD  ");
 Lcd_Out(2, 1, "       ");
 thr_disp = pi_thr - 511;
 extract_and_disp(thr_disp, 10, 2, 8);
 extract_and_disp(thr_disp, 1, 2, 9);
 Lcd_Out(2, 10, "       ");
 if (keypad_btn == up_btn) {
 pi_thr++;
 if (pi_thr > 531) {pi_thr = 531;}
 }
 if (keypad_btn == down_btn) {
 pi_thr--;
 if (pi_thr < 511) {pi_thr = 511;}
 }
 break;
 case 2:
 Lcd_Out(1, 1, " PI PULSE WIDTH ");
 Lcd_Out(2, 1, "     ");
 extract_and_disp(txon, 100, 2, 6);
 extract_and_disp(txon, 10, 2, 7);
 extract_and_disp(txon, 1, 2, 8);
 Lcd_Out(2, 9, "us      ");
 if (keypad_btn == up_btn) {
 txon += 10;
 if (txon > 200) {txon = 200;}
 }
 if (keypad_btn == down_btn) {
 txon -= 10;
 if (txon < 10) {txon = 10;}
 }
 break;
 case 3:
 Lcd_Out(1, 1, "PI SAMPLE DELAY ");
 Lcd_Out(2, 1, "      ");
 extract_and_disp(main_dly, 10, 2, 7);
 extract_and_disp(main_dly, 1, 2, 8);
 Lcd_Out(2, 9, "us      ");
 if (keypad_btn == up_btn) {
 main_dly++;
 if (main_dly > 60) {main_dly = 60;}
 }
 if (keypad_btn == down_btn) {
 main_dly--;
 if (main_dly < 10) {main_dly = 10;}
 }
 break;
 case 4:
 Lcd_Out(1, 1, "PI SAMPLE WIDTH ");
 Lcd_Out(2, 1, "     ");
 extract_and_disp(main_smpl, 100, 2, 6);
 extract_and_disp(main_smpl, 10, 2, 7);
 extract_and_disp(main_smpl, 1, 2, 8);
 Lcd_Out(2, 9, "us      ");
 if (keypad_btn == up_btn) {
 main_smpl++;
 if (main_smpl > 60) {main_smpl = 60;}
 }
 if (keypad_btn == down_btn) {
 main_smpl--;
 if (main_smpl < 20) {main_smpl = 20;}
 }
 break;
 case 5:
 Lcd_Out(1, 1, "   PI AVERAGE   ");
 Lcd_Out(2, 1, "       ");
 extract_and_disp(pi_num, 10, 2, 8);
 extract_and_disp(pi_num, 1, 2, 9);
 Lcd_Out(2, 10, "       ");
 if (keypad_btn == up_btn) {
 pi_num++;
 if (pi_num > 64) {pi_num = 64;}
 }
 if (keypad_btn == down_btn) {
 pi_num--;
 if (pi_num < 1) {pi_num = 1;}
 }
 break;
 case 6:
 Lcd_Out(1, 1, " DISC THRESHOLD ");
 Lcd_Out(2, 1, "       ");
 thr_disp = disc_thr - 511;
 extract_and_disp(thr_disp, 10, 2, 8);
 extract_and_disp(thr_disp, 1, 2, 9);
 Lcd_Out(2, 10, "       ");
 if (keypad_btn == up_btn) {
 disc_thr++;
 if (disc_thr > 531) {disc_thr = 531;}
 }
 if (keypad_btn == down_btn) {
 disc_thr--;
 if (disc_thr < 511) {disc_thr = 511;}
 }
 break;
 case 7:
 Lcd_Out(1, 1, "DISC SMPL DELAY ");
 Lcd_Out(2, 1, "     ");
 extract_and_disp(disc_dly, 100, 2, 6);
 extract_and_disp(disc_dly, 10, 2, 7);
 extract_and_disp(disc_dly, 1, 2, 8);
 Lcd_Out(2, 9, "us      ");
 if (keypad_btn == up_btn) {
 disc_dly++;
 if (disc_dly > 100) {disc_dly = 100;}
 }
 if (keypad_btn == down_btn) {
 disc_dly--;
 if (disc_dly < 20) {disc_dly = 20;}
 }
 break;
 case 8:
 Lcd_Out(1, 1, "DISC SMPL WIDTH ");
 Lcd_Out(2, 1, "     ");
 extract_and_disp(disc_smpl, 100, 2, 6);
 extract_and_disp(disc_smpl, 10, 2, 7);
 extract_and_disp(disc_smpl, 1, 2, 8);
 Lcd_Out(2, 9, "us      ");
 if (keypad_btn == up_btn) {
 disc_smpl++;
 if (disc_smpl > 100) {main_smpl = 100;}
 }
 if (keypad_btn == down_btn) {
 disc_smpl--;
 if (disc_smpl < 10) {disc_smpl = 10;}
 }
 break;
 case 9:
 Lcd_Out(1, 1, "  DISC AVERAGE  ");
 Lcd_Out(2, 1, "       ");
 extract_and_disp(disc_num, 10, 2, 8);
 extract_and_disp(disc_num, 1, 2, 9);
 Lcd_Out(2, 10, "       ");
 if (keypad_btn == up_btn) {
 disc_num++;
 if (disc_num > 64) {disc_num = 64;}
 }
 if (keypad_btn == down_btn) {
 disc_num--;
 if (disc_num < 1) {disc_num = 1;}
 }
 break;
 case 10:
 Lcd_Out(1, 1, "METER ZERO LIMIT");
 Lcd_Out(2, 1, "       ");
 extract_and_disp(meter_zero_limit, 10, 2, 8);
 extract_and_disp(meter_zero_limit, 1, 2, 9);
 Lcd_Out(2, 10, "       ");
 if (keypad_btn == up_btn) {
 meter_zero_limit++;
 if (meter_zero_limit > 20) {meter_zero_limit = 20;}
 }
 if (keypad_btn == down_btn) {
 meter_zero_limit--;
 if (meter_zero_limit < 5) {meter_zero_limit = 5;}
 }
 break;
 case 11:
 Lcd_Out(1, 1, " COUNTER LIMIT  ");
 Lcd_Out(2, 1, "      ");
 extract_and_disp(counter_limit, 100, 2, 7);
 extract_and_disp(counter_limit, 10, 2, 8);
 extract_and_disp(counter_limit, 1, 2, 9);
 Lcd_Out(2, 10, "       ");
 if (keypad_btn == up_btn) {
 counter_limit += 10;
 if (counter_limit > 150) {counter_limit = 150;}
 }
 if (keypad_btn == down_btn) {
 counter_limit -= 10;
 if (counter_limit < 10) {counter_limit = 10;}
 }
 break;
 }
 keypad_btn = scan_keypad();
 if (keypad_btn == menu_btn) {
 menu_flag = menu_inactive;
 write_eeprom();
 calc_txon();
 calc_txpd();
 calc_main_dly();
 calc_main_smpl();
 calc_efe_dly();
 calc_efe_smpl();
 calc_disc_dly();
 calc_disc_smpl();



 EEPROM_Write(20, txonh);
 EEPROM_Write(21, txonl);
 EEPROM_Write(22, main_dlyh);
 EEPROM_Write(23, main_dlyl);
 EEPROM_Write(24, main_smplh);
 EEPROM_Write(25, main_smpll);
 EEPROM_Write(26, efe_dlyh);
 EEPROM_Write(27, efe_dlyl);
 EEPROM_Write(28, txpdh);
 EEPROM_Write(29, txpdl);


 clear_arrays();
 int_state = 0;
 PIE1 = 0x01;
 INTCON = 0xE0;
 } else {
 if (keypad_btn == enter_btn) {
 switch (menu_disp) {
 case 0:
 if (detect_mode == hybrid) {
 menu_disp = 6;
 } else {
 menu_disp = 1;
 }
 break;
 case 1:
 menu_disp = 2;
 break;
 case 2:
 menu_disp = 3;
 break;
 case 3:
 menu_disp = 4;
 break;
 case 4:
 menu_disp = 5;
 break;
 case 5:
 menu_disp = 0;
 break;
 case 6:
 menu_disp = 7;
 break;
 case 7:
 menu_disp = 8;
 break;
 case 8:
 menu_disp = 9;
 break;
 case 9:
 menu_disp = 10;
 break;
 case 10:
 menu_disp = 11;
 break;
 case 11:
 menu_disp = 0;
 break;
 }
 }
 }
 }
}

void disp_reset() {
 if (detect_mode == pulse) {
 Lcd_Out(1, 1, " PULSE   ");
 } else {
 Lcd_Out(1, 1, " HYBRID  ");
 }
 Lcd_Out(2, 1, "       ");
 Lcd_Chr(2, 8, 7);
 Lcd_Out(2, 9, "        ");
}


void main() {

 TRISA =  0x0F; ;
 TRISB =  0xC0; ;
 TRISC =  0xF0; ;
 TRISD =  0x38; ;
 TRISE =  0x06; ;


 EN1 =  0; ;
 main_pulse =  1; ;
 efe_pulse =  1; ;
 disc_pulse =  1; ;


 ADCON1 = 0x07;
 ADC_Init();


 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);


 Lcd_Cmd(64);

 Lcd_Chr_Cp(14);
 for (i = 2; i <= 8; i++) {Lcd_Chr_Cp(31);}

 Lcd_Chr_Cp(14);
 Lcd_Chr_Cp(31);
 Lcd_Chr_Cp(17);
 for (i = 4; i <= 8; i++) {Lcd_Chr_Cp(31);}

 Lcd_Chr_Cp(14);
 Lcd_Chr_Cp(31);
 for (i = 3; i <= 4; i++) {Lcd_Chr_Cp(17);}
 for (i = 5; i <= 8; i++) {Lcd_Chr_Cp(31);}

 Lcd_Chr_Cp(14);
 Lcd_Chr_Cp(31);
 for (i = 3; i <= 5; i++) {Lcd_Chr_Cp(17);}
 for (i = 6; i <= 8; i++) {Lcd_Chr_Cp(31);}

 Lcd_Chr_Cp(14);
 Lcd_Chr_Cp(31);
 for (i = 3; i <= 6; i++) {Lcd_Chr_Cp(17);}
 for (i = 7; i <= 8; i++) {Lcd_Chr_Cp(31);}

 Lcd_Chr_Cp(14);
 Lcd_Chr_Cp(31);
 for (i = 3; i <= 7; i++) {Lcd_Chr_Cp(17);}
 Lcd_Chr_Cp(31);

 for (i = 1; i <= 8; i++) {Lcd_Chr_Cp(31);}

 for (i = 1; i <= 8; i++) {Lcd_Chr_Cp(4);}


 Lcd_Out(1,1,"  VOODOO V1.1   ");
 Lcd_Out(2,1,"HYBRID DETECTOR ");
 delay_ms(2000);
 Lcd_Cmd(_LCD_CLEAR);


 int_state = 0;
 main_state = 0;
 loop_count = 0;
 hybrid_cycle = 0;
 accept = 0;
 accept_blk = 0;
 reject = 0;
 reject_blk = 0;
 update_disp = 0;
 meter_zero = 0;


 detect_mode = hybrid;
 pi_thr = 525;
 disc_thr = 511;
 txon = 150;
 txpd = 1000;
 main_dly = 27;
 main_smpl = 60;
 efe_dly = 400;
 pi_num = 64;
 disc_dly = 45;
 disc_smpl = 45;
 disc_num = 64;
 meter_zero_limit = 10;
 counter_limit = 100;

 clear_arrays();


 if (EEPROM_Read(0) == 0xAA) {
 detect_mode = EEPROM_Read(1);
 pi_thr = EEPROM_Read(2);
 pi_thr = pi_thr << 8;
 pi_thr += EEPROM_Read(3);
 txon = EEPROM_Read(4);
 txpd = EEPROM_Read(5);
 txpd = txpd << 8;
 txpd += EEPROM_Read(6);
 main_dly = EEPROM_Read(7);
 main_smpl = EEPROM_Read(8);
 efe_dly = EEPROM_Read(9);
 efe_dly = efe_dly << 8;
 efe_dly += EEPROM_Read(10);
 pi_num = EEPROM_Read(11);
 disc_thr = EEPROM_Read(12);
 disc_thr = disc_thr << 8;
 disc_thr += EEPROM_Read(13);
 disc_dly = EEPROM_Read(14);
 disc_smpl = EEPROM_Read(15);
 disc_num = EEPROM_Read(16);
 meter_zero_limit = EEPROM_Read(17);
 counter_limit = EEPROM_Read(18);
 } else{
 write_eeprom();
 }
 calc_txon();
 calc_txpd();
 calc_main_dly();
 calc_main_smpl();
 calc_efe_dly();
 calc_efe_smpl();
 calc_disc_dly();
 calc_disc_smpl();
 disp_reset();




 T0CON = 0x88;
 T1CON = 0x85;
 TMR0H = txonh;
 TMR0L = txonl;
 TMR1H = txpdh;
 TMR1H = txpdl;
 PIR1 = 0x00;
 PIE1 = 0x01;
 INTCON = 0xE0;

 while(1) {
 switch (main_state) {
 case 0:
 pi_target = Adc_Read(pi_adc);
 pi_tmp = pi_array[pi_pointer];
 pi_array[pi_pointer] = pi_target;
 pi_total = (pi_total + pi_target) - pi_tmp;
 pi_target = pi_total / pi_num;
 pi_pointer++;
 if (pi_pointer >= pi_num) {
 pi_pointer = 0;
 }
 if (detect_mode == hybrid) {
 disc_target = Adc_Read(disc_adc);
 disc_tmp = disc_array[disc_pointer];
 disc_array[disc_pointer] = disc_target;
 disc_total = (disc_total + disc_target) - disc_tmp;
 disc_target = disc_total / disc_num;
 disc_pointer++;
 if (disc_pointer >= disc_num) {
 disc_pointer = 0;
 }
 }

 if (pi_target >= pi_thr) {
 if (detect_mode == hybrid) {
 update_disp = 0;
 if (disc_target >= disc_thr) {
 audio_en =  1; ;
 if (reject_blk == 0) {
 accept++;
 reject = 0;
 if (accept > counter_limit) {
 accept = 0;
 accept_blk++;
 if (accept_blk <= blk_limit) {
 update_disp = 1;
 } else {
 accept_blk = blk_limit;
 }
 }
 } else {
 if (reject != 0) {
 reject--;
 } else {
 reject = counter_limit;
 if (reject_blk != 0) {
 reject_blk--;
 update_disp = 1;
 }
 }
 }
 } else {
 audio_en =  0; ;
 if (accept_blk == 0) {
 reject++;
 accept = 0;
 if (reject > counter_limit) {
 reject = 0;
 reject_blk++;
 if (reject_blk <= blk_limit) {
 update_disp = 1;
 } else {
 reject_blk = blk_limit;
 }
 }
 } else {
 if (accept != 0) {
 accept--;
 } else {
 accept = counter_limit;
 if (accept_blk != 0) {
 accept_blk--;
 update_disp = 1;
 }
 }
 }
 }

 } else {
 audio_en =  1; ;
 }
 } else {
 audio_en =  0; ;
 }
 if (update_disp == 0) {
 meter_zero++;
 if (meter_zero >= meter_zero_limit) {
 if (accept_blk != 0) {
 if (accept != 0) {
 accept--;
 } else {
 accept_blk--;
 accept = counter_limit;
 update_disp = 1;
 }
 } else {
 if (reject_blk != 0) {
 if (reject != 0) {
 reject--;
 } else {
 reject_blk--;
 reject = counter_limit;
 update_disp = 1;
 }
 }
 }
 meter_zero = 0;
 }
 }
 if (update_disp == 1) {
 if (accept_blk != 0) {
 for (i = 1; i <= accept_blk; i++) {
 Lcd_Chr(2, 8 + i, 6);
 }
 if (accept_blk != blk_limit) {
 for (i = accept_blk + 1; i <= blk_limit; i++) {
 Lcd_Chr(2, 8 + i, 32);
 }
 }
 } else {
 Lcd_Chr(2, 9, 32);
 if (reject_blk != 0) {
 for (i = 1; i <= reject_blk; i++) {
 Lcd_Chr(2, 8 - i, 6);
 }
 if (reject_blk != blk_limit) {
 for (i = reject_blk + 1; i <= blk_limit; i++) {
 Lcd_Chr(2, 8 - i, 32);
 }
 }
 } else {
 Lcd_Chr(2, 7, 32);
 }
 }
 update_disp = 0;
 }
 keypad_btn = scan_keypad();
 if (keypad_btn == menu_btn) {
 menu_system();
 disp_reset();
 }
 loop_count++;
 main_state = (loop_count == 128)?1:0;
 break;
 case 1:
 battery_measure();
 battery_display();
 battery_symbol();
 loop_count = 0;
 main_state = 0;
 break;
 }
 }
 }
