
_interrupt:

;Voodoo_V1.c,165 :: 		void interrupt() {
;Voodoo_V1.c,166 :: 		switch (int_state) {
	GOTO        L_interrupt0
;Voodoo_V1.c,167 :: 		case 0:                                      // TX on - charge coil
L_interrupt2:
;Voodoo_V1.c,168 :: 		EN1 = EN1_on;                              // Turn on MOSFET
	BSF         LATD6_bit+0, BitPos(LATD6_bit+0) 
;Voodoo_V1.c,169 :: 		TMR0H = txonh;                             // Load TMR0 for TX pulse
	MOVF        _txonh+0, 0 
	MOVWF       TMR0H+0 
;Voodoo_V1.c,170 :: 		TMR0L = txonl;
	MOVF        _txonl+0, 0 
	MOVWF       TMR0L+0 
;Voodoo_V1.c,171 :: 		TMR1H = txpdh;                             // Load TMR1 for TX period
	MOVF        _txpdh+0, 0 
	MOVWF       TMR1H+0 
;Voodoo_V1.c,172 :: 		TMR1L = txpdl;
	MOVF        _txpdl+0, 0 
	MOVWF       TMR1L+0 
;Voodoo_V1.c,173 :: 		ps_sync = 1;                               // Sync power supply
	BSF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;Voodoo_V1.c,174 :: 		debug = 1;
	BSF         LATD2_bit+0, BitPos(LATD2_bit+0) 
;Voodoo_V1.c,175 :: 		PIR1 = 0x00;                               // Clear TMR1 overflow interrupt flag
	CLRF        PIR1+0 
;Voodoo_V1.c,176 :: 		INTCON = 0xE0;                             // Clear TMR0 overflow interrupt flag
	MOVLW       224
	MOVWF       INTCON+0 
;Voodoo_V1.c,177 :: 		if (hybrid_cycle == 0) {
	MOVF        _hybrid_cycle+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_interrupt3
;Voodoo_V1.c,178 :: 		int_state = 1;                           // Pulse sample
	MOVLW       1
	MOVWF       _int_state+0 
;Voodoo_V1.c,179 :: 		} else {
	GOTO        L_interrupt4
L_interrupt3:
;Voodoo_V1.c,180 :: 		int_state = 6;                           // Disc sample
	MOVLW       6
	MOVWF       _int_state+0 
;Voodoo_V1.c,181 :: 		}
L_interrupt4:
;Voodoo_V1.c,182 :: 		break;
	GOTO        L_interrupt1
;Voodoo_V1.c,183 :: 		case 1:                                      // TX off - discharge coil
L_interrupt5:
;Voodoo_V1.c,184 :: 		EN1 = EN1_off;                             // Turn off MOSFET
	BCF         LATD6_bit+0, BitPos(LATD6_bit+0) 
;Voodoo_V1.c,185 :: 		TMR0H = main_dlyh;                         // Load TMR0 for main sample delay
	MOVF        _main_dlyh+0, 0 
	MOVWF       TMR0H+0 
;Voodoo_V1.c,186 :: 		TMR0L = main_dlyl;
	MOVF        _main_dlyl+0, 0 
	MOVWF       TMR0L+0 
;Voodoo_V1.c,187 :: 		ps_sync = 0;                               // Sync power supply
	BCF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;Voodoo_V1.c,188 :: 		debug = 0;
	BCF         LATD2_bit+0, BitPos(LATD2_bit+0) 
;Voodoo_V1.c,189 :: 		INTCON = 0xE0;                             // Clear TMR0 overflow interrupt flag
	MOVLW       224
	MOVWF       INTCON+0 
;Voodoo_V1.c,190 :: 		int_state = 2;
	MOVLW       2
	MOVWF       _int_state+0 
;Voodoo_V1.c,191 :: 		break;
	GOTO        L_interrupt1
;Voodoo_V1.c,192 :: 		case 2:                                      // Main sample pulse on
L_interrupt6:
;Voodoo_V1.c,193 :: 		main_pulse = main_on;                      // Turn on main sample
	BCF         LATC3_bit+0, BitPos(LATC3_bit+0) 
;Voodoo_V1.c,194 :: 		TMR0H = main_smplh;                        // Load TMR0 for main sample width
	MOVF        _main_smplh+0, 0 
	MOVWF       TMR0H+0 
;Voodoo_V1.c,195 :: 		TMR0L = main_smpll;
	MOVF        _main_smpll+0, 0 
	MOVWF       TMR0L+0 
;Voodoo_V1.c,196 :: 		ps_sync = 1;                               // Sync power supply
	BSF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;Voodoo_V1.c,197 :: 		INTCON = 0xE0;                             // Clear TMR0 overflow interrupt flag
	MOVLW       224
	MOVWF       INTCON+0 
;Voodoo_V1.c,198 :: 		int_state = 3;
	MOVLW       3
	MOVWF       _int_state+0 
;Voodoo_V1.c,199 :: 		break;
	GOTO        L_interrupt1
;Voodoo_V1.c,200 :: 		case 3:                                      // Main sample pulse off
L_interrupt7:
;Voodoo_V1.c,201 :: 		main_pulse = main_off;                     // Turn off main sample
	BSF         LATC3_bit+0, BitPos(LATC3_bit+0) 
;Voodoo_V1.c,202 :: 		TMR0H = efe_dlyh;                          // Load TMR0 for EFE sample delay
	MOVF        _efe_dlyh+0, 0 
	MOVWF       TMR0H+0 
;Voodoo_V1.c,203 :: 		TMR0L = efe_dlyl;
	MOVF        _efe_dlyl+0, 0 
	MOVWF       TMR0L+0 
;Voodoo_V1.c,204 :: 		ps_sync = 0;                               // Sync power supply
	BCF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;Voodoo_V1.c,205 :: 		INTCON = 0xE0;                             // Clear TMR0 overflow interrupt flag
	MOVLW       224
	MOVWF       INTCON+0 
;Voodoo_V1.c,206 :: 		int_state = 4;
	MOVLW       4
	MOVWF       _int_state+0 
;Voodoo_V1.c,207 :: 		break;
	GOTO        L_interrupt1
;Voodoo_V1.c,208 :: 		case 4:                                      // EFE sample pulse on
L_interrupt8:
;Voodoo_V1.c,209 :: 		efe_pulse = efe_on;                        // Turn on EFE sample
	BCF         LATD0_bit+0, BitPos(LATD0_bit+0) 
;Voodoo_V1.c,210 :: 		TMR0H = efe_smplh;                         // Load TMR0 for EFE sample width
	MOVF        _efe_smplh+0, 0 
	MOVWF       TMR0H+0 
;Voodoo_V1.c,211 :: 		TMR0L = efe_smpll;
	MOVF        _efe_smpll+0, 0 
	MOVWF       TMR0L+0 
;Voodoo_V1.c,212 :: 		ps_sync = 1;                               // Sync power supply
	BSF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;Voodoo_V1.c,213 :: 		INTCON = 0xE0;                             // Clear TMR0 overflow interrupt flag
	MOVLW       224
	MOVWF       INTCON+0 
;Voodoo_V1.c,214 :: 		int_state = 5;
	MOVLW       5
	MOVWF       _int_state+0 
;Voodoo_V1.c,215 :: 		break;
	GOTO        L_interrupt1
;Voodoo_V1.c,216 :: 		case 5:                                      // EFE sample pulse off
L_interrupt9:
;Voodoo_V1.c,217 :: 		efe_pulse = efe_off;                       // Turn off EFE sample
	BSF         LATD0_bit+0, BitPos(LATD0_bit+0) 
;Voodoo_V1.c,218 :: 		TMR0H = 0x00;                              // Load TMR0 with maximum delay
	CLRF        TMR0H+0 
;Voodoo_V1.c,219 :: 		TMR0L = 0x00;
	CLRF        TMR0L+0 
;Voodoo_V1.c,220 :: 		ps_sync = 0;
	BCF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;Voodoo_V1.c,221 :: 		INTCON = 0xE0;                             // Clear TMR0 overflow interrupt flag
	MOVLW       224
	MOVWF       INTCON+0 
;Voodoo_V1.c,222 :: 		if (detect_mode == pulse) {                // Check detector mode (pulse or hybrid)
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt245
	MOVLW       0
	XORWF       _detect_mode+0, 0 
L__interrupt245:
	BTFSS       STATUS+0, 2 
	GOTO        L_interrupt10
;Voodoo_V1.c,223 :: 		hybrid_cycle = 0;                        // Continue with pulse sampling
	CLRF        _hybrid_cycle+0 
;Voodoo_V1.c,224 :: 		} else {
	GOTO        L_interrupt11
L_interrupt10:
;Voodoo_V1.c,225 :: 		hybrid_cycle = 1;                        // Switch to disc sampling
	MOVLW       1
	MOVWF       _hybrid_cycle+0 
;Voodoo_V1.c,226 :: 		}
L_interrupt11:
;Voodoo_V1.c,227 :: 		int_state = 0;
	CLRF        _int_state+0 
;Voodoo_V1.c,228 :: 		break;
	GOTO        L_interrupt1
;Voodoo_V1.c,229 :: 		case 6:                                      // TX off - discharge coil
L_interrupt12:
;Voodoo_V1.c,230 :: 		EN1 = EN1_off;                             // Turn off MOSFET
	BCF         LATD6_bit+0, BitPos(LATD6_bit+0) 
;Voodoo_V1.c,231 :: 		TMR0H = disc_dlyh;                         // Load TMR0 for DISC sample delay
	MOVF        _disc_dlyh+0, 0 
	MOVWF       TMR0H+0 
;Voodoo_V1.c,232 :: 		TMR0L = disc_dlyl;
	MOVF        _disc_dlyl+0, 0 
	MOVWF       TMR0L+0 
;Voodoo_V1.c,233 :: 		ps_sync = 0;                               // Sync power supply
	BCF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;Voodoo_V1.c,234 :: 		debug = 0;
	BCF         LATD2_bit+0, BitPos(LATD2_bit+0) 
;Voodoo_V1.c,235 :: 		INTCON = 0xE0;                             // Clear TMR0 overflow interrupt flag
	MOVLW       224
	MOVWF       INTCON+0 
;Voodoo_V1.c,236 :: 		int_state = 7;
	MOVLW       7
	MOVWF       _int_state+0 
;Voodoo_V1.c,237 :: 		break;
	GOTO        L_interrupt1
;Voodoo_V1.c,238 :: 		case 7:                                      // Disc sample pulse on
L_interrupt13:
;Voodoo_V1.c,239 :: 		disc_pulse = disc_on;                      // Turn on disc sample pulse
	BCF         LATC1_bit+0, BitPos(LATC1_bit+0) 
;Voodoo_V1.c,240 :: 		TMR0H = disc_smplh;                        // Load TMR0 for disc sample pulse width
	MOVF        _disc_smplh+0, 0 
	MOVWF       TMR0H+0 
;Voodoo_V1.c,241 :: 		TMR0L = disc_smpll;
	MOVF        _disc_smpll+0, 0 
	MOVWF       TMR0L+0 
;Voodoo_V1.c,242 :: 		ps_sync = 1;                               // Sync power supply
	BSF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;Voodoo_V1.c,243 :: 		INTCON = 0xE0;                             // Clear TMR0 overflow interrupt flag
	MOVLW       224
	MOVWF       INTCON+0 
;Voodoo_V1.c,244 :: 		int_state = 8;
	MOVLW       8
	MOVWF       _int_state+0 
;Voodoo_V1.c,245 :: 		break;
	GOTO        L_interrupt1
;Voodoo_V1.c,246 :: 		case 8:                                      // Disc sample pulse off
L_interrupt14:
;Voodoo_V1.c,247 :: 		disc_pulse = disc_off;                     // Turn off disc sample pulse
	BSF         LATC1_bit+0, BitPos(LATC1_bit+0) 
;Voodoo_V1.c,248 :: 		TMR0H = 0x00;                              // Load TMR0 with maximum delay
	CLRF        TMR0H+0 
;Voodoo_V1.c,249 :: 		TMR0L = 0x00;
	CLRF        TMR0L+0 
;Voodoo_V1.c,250 :: 		ps_sync = 0;                               // Sync power supply
	BCF         LATC0_bit+0, BitPos(LATC0_bit+0) 
;Voodoo_V1.c,251 :: 		INTCON = 0xE0;                             // Clear TMR0 overflow interrupt flag
	MOVLW       224
	MOVWF       INTCON+0 
;Voodoo_V1.c,252 :: 		hybrid_cycle = 0;                          // Switch to pulse sampling
	CLRF        _hybrid_cycle+0 
;Voodoo_V1.c,253 :: 		int_state = 0;
	CLRF        _int_state+0 
;Voodoo_V1.c,254 :: 		break;
	GOTO        L_interrupt1
;Voodoo_V1.c,255 :: 		}
L_interrupt0:
	MOVF        _int_state+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_interrupt2
	MOVF        _int_state+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_interrupt5
	MOVF        _int_state+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_interrupt6
	MOVF        _int_state+0, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L_interrupt7
	MOVF        _int_state+0, 0 
	XORLW       4
	BTFSC       STATUS+0, 2 
	GOTO        L_interrupt8
	MOVF        _int_state+0, 0 
	XORLW       5
	BTFSC       STATUS+0, 2 
	GOTO        L_interrupt9
	MOVF        _int_state+0, 0 
	XORLW       6
	BTFSC       STATUS+0, 2 
	GOTO        L_interrupt12
	MOVF        _int_state+0, 0 
	XORLW       7
	BTFSC       STATUS+0, 2 
	GOTO        L_interrupt13
	MOVF        _int_state+0, 0 
	XORLW       8
	BTFSC       STATUS+0, 2 
	GOTO        L_interrupt14
L_interrupt1:
;Voodoo_V1.c,256 :: 		}
L_end_interrupt:
L__interrupt244:
	RETFIE      1
; end of _interrupt

_extract_and_disp:

;Voodoo_V1.c,263 :: 		char col) {                                    // Select column on LCD
;Voodoo_V1.c,265 :: 		ch = value / divisor % 10;                     // Extract selected digit
	MOVF        FARG_extract_and_disp_divisor+0, 0 
	MOVWF       R4 
	MOVF        FARG_extract_and_disp_divisor+1, 0 
	MOVWF       R5 
	MOVF        FARG_extract_and_disp_value+0, 0 
	MOVWF       R0 
	MOVF        FARG_extract_and_disp_value+1, 0 
	MOVWF       R1 
	CALL        _Div_16X16_U+0, 0
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Div_16X16_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
;Voodoo_V1.c,266 :: 		Lcd_Chr(row, col, 48 + ch);                    // Display selected digit
	MOVF        FARG_extract_and_disp_row+0, 0 
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVF        FARG_extract_and_disp_col+0, 0 
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        R0, 0 
	ADDLW       48
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;Voodoo_V1.c,267 :: 		}
L_end_extract_and_disp:
	RETURN      0
; end of _extract_and_disp

_battery_measure:

;Voodoo_V1.c,270 :: 		void battery_measure() {
;Voodoo_V1.c,271 :: 		t = 0;                                         // Clear battery voltage accumulator
	CLRF        _t+0 
	CLRF        _t+1 
;Voodoo_V1.c,272 :: 		for (i = 1; i <= 8; i++) {
	MOVLW       1
	MOVWF       _i+0 
	MOVLW       0
	MOVWF       _i+1 
L_battery_measure15:
	MOVLW       0
	MOVWF       R0 
	MOVF        _i+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__battery_measure248
	MOVF        _i+0, 0 
	SUBLW       8
L__battery_measure248:
	BTFSS       STATUS+0, 0 
	GOTO        L_battery_measure16
;Voodoo_V1.c,273 :: 		t += ADC_Read(batt_adc);                     // Accumulate battery voltage readings
	MOVF        _batt_adc+0, 0 
	MOVWF       FARG_ADC_Read_channel+0 
	CALL        _ADC_Read+0, 0
	MOVF        R0, 0 
	ADDWF       _t+0, 1 
	MOVF        R1, 0 
	ADDWFC      _t+1, 1 
;Voodoo_V1.c,272 :: 		for (i = 1; i <= 8; i++) {
	INFSNZ      _i+0, 1 
	INCF        _i+1, 1 
;Voodoo_V1.c,274 :: 		}
	GOTO        L_battery_measure15
L_battery_measure16:
;Voodoo_V1.c,275 :: 		t = t / 8;                                     // Average readings
	MOVF        _t+0, 0 
	MOVWF       R0 
	MOVF        _t+1, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	MOVF        R0, 0 
	MOVWF       _t+0 
	MOVF        R1, 0 
	MOVWF       _t+1 
;Voodoo_V1.c,276 :: 		t = (5000 - (t * 5)) * 3 / 100;                // Calculate battery voltage
	MOVLW       5
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVF        R0, 0 
	SUBLW       136
	MOVWF       R0 
	MOVF        R1, 0 
	MOVWF       R1 
	MOVLW       19
	SUBFWB      R1, 1 
	MOVLW       3
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVLW       100
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Div_16X16_U+0, 0
	MOVF        R0, 0 
	MOVWF       _t+0 
	MOVF        R1, 0 
	MOVWF       _t+1 
;Voodoo_V1.c,277 :: 		}
L_end_battery_measure:
	RETURN      0
; end of _battery_measure

_battery_display:

;Voodoo_V1.c,280 :: 		void battery_display() {
;Voodoo_V1.c,281 :: 		extract_and_disp(t, 100, 1, 10);
	MOVF        _t+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVF        _t+1, 0 
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       100
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       1
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       10
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,282 :: 		extract_and_disp(t, 10, 1, 11);
	MOVF        _t+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVF        _t+1, 0 
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       10
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       1
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       11
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,283 :: 		Lcd_Out(1, 12, ".");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       12
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr1_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr1_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,284 :: 		extract_and_disp(t, 1, 1, 13);
	MOVF        _t+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVF        _t+1, 0 
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       1
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       1
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       13
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,285 :: 		Lcd_Out(1, 14, "V ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       14
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr2_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr2_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,286 :: 		}
L_end_battery_display:
	RETURN      0
; end of _battery_display

_battery_symbol:

;Voodoo_V1.c,289 :: 		void battery_symbol() {
;Voodoo_V1.c,290 :: 		if (t >= 120)
	MOVLW       0
	SUBWF       _t+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__battery_symbol251
	MOVLW       120
	SUBWF       _t+0, 0 
L__battery_symbol251:
	BTFSS       STATUS+0, 0 
	GOTO        L_battery_symbol18
;Voodoo_V1.c,291 :: 		Lcd_Chr(1, 16, 0);
	MOVLW       1
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       16
	MOVWF       FARG_Lcd_Chr_column+0 
	CLRF        FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
	GOTO        L_battery_symbol19
L_battery_symbol18:
;Voodoo_V1.c,292 :: 		else if (t >= 117)
	MOVLW       0
	SUBWF       _t+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__battery_symbol252
	MOVLW       117
	SUBWF       _t+0, 0 
L__battery_symbol252:
	BTFSS       STATUS+0, 0 
	GOTO        L_battery_symbol20
;Voodoo_V1.c,293 :: 		Lcd_Chr(1, 16, 1);
	MOVLW       1
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       16
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
	GOTO        L_battery_symbol21
L_battery_symbol20:
;Voodoo_V1.c,294 :: 		else if (t >= 114)
	MOVLW       0
	SUBWF       _t+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__battery_symbol253
	MOVLW       114
	SUBWF       _t+0, 0 
L__battery_symbol253:
	BTFSS       STATUS+0, 0 
	GOTO        L_battery_symbol22
;Voodoo_V1.c,295 :: 		Lcd_Chr(1, 16, 2);
	MOVLW       1
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       16
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
	GOTO        L_battery_symbol23
L_battery_symbol22:
;Voodoo_V1.c,296 :: 		else if (t >= 111)
	MOVLW       0
	SUBWF       _t+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__battery_symbol254
	MOVLW       111
	SUBWF       _t+0, 0 
L__battery_symbol254:
	BTFSS       STATUS+0, 0 
	GOTO        L_battery_symbol24
;Voodoo_V1.c,297 :: 		Lcd_Chr(1, 16, 3);
	MOVLW       1
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       16
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
	GOTO        L_battery_symbol25
L_battery_symbol24:
;Voodoo_V1.c,298 :: 		else if (t >= 108)
	MOVLW       0
	SUBWF       _t+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__battery_symbol255
	MOVLW       108
	SUBWF       _t+0, 0 
L__battery_symbol255:
	BTFSS       STATUS+0, 0 
	GOTO        L_battery_symbol26
;Voodoo_V1.c,299 :: 		Lcd_Chr(1, 16, 4);
	MOVLW       1
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       16
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       4
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
	GOTO        L_battery_symbol27
L_battery_symbol26:
;Voodoo_V1.c,300 :: 		else if (t >= 105)
	MOVLW       0
	SUBWF       _t+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__battery_symbol256
	MOVLW       105
	SUBWF       _t+0, 0 
L__battery_symbol256:
	BTFSS       STATUS+0, 0 
	GOTO        L_battery_symbol28
;Voodoo_V1.c,301 :: 		Lcd_Chr(1, 16, 5);
	MOVLW       1
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       16
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       5
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
	GOTO        L_battery_symbol29
L_battery_symbol28:
;Voodoo_V1.c,303 :: 		Lcd_Out(1, 16, "X");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       16
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr3_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr3_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
L_battery_symbol29:
L_battery_symbol27:
L_battery_symbol25:
L_battery_symbol23:
L_battery_symbol21:
L_battery_symbol19:
;Voodoo_V1.c,304 :: 		}
L_end_battery_symbol:
	RETURN      0
; end of _battery_symbol

_calc_txon:

;Voodoo_V1.c,306 :: 		void calc_txon() {                               // Calculate TX pulse width
;Voodoo_V1.c,307 :: 		tmp = 65535 - ((txon - txon_offset) / 2) * 10;
	MOVLW       4
	SUBWF       _txon+0, 0 
	MOVWF       R3 
	MOVLW       0
	MOVWF       R4 
	MOVLW       0
	SUBFWB      R4, 1 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	BTFSC       R1, 6 
	BSF         R1, 7 
	BTFSS       R1, 7 
	GOTO        L__calc_txon258
	BTFSS       STATUS+0, 0 
	GOTO        L__calc_txon258
	INFSNZ      R0, 1 
	INCF        R1, 1 
L__calc_txon258:
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVF        R0, 0 
	SUBLW       255
	MOVWF       R3 
	MOVF        R1, 0 
	MOVWF       R4 
	MOVLW       255
	SUBFWB      R4, 1 
	MOVF        R3, 0 
	MOVWF       _tmp+0 
	MOVF        R4, 0 
	MOVWF       _tmp+1 
;Voodoo_V1.c,308 :: 		txonh = tmp >> 8;
	MOVF        R4, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       _txonh+0 
;Voodoo_V1.c,309 :: 		txonl = tmp - (txonh << 8);
	MOVF        R3, 0 
	MOVWF       _txonl+0 
;Voodoo_V1.c,310 :: 		}
L_end_calc_txon:
	RETURN      0
; end of _calc_txon

_calc_txpd:

;Voodoo_V1.c,312 :: 		void calc_txpd() {                               // Calculate TX period
;Voodoo_V1.c,313 :: 		tmp = 65535 - ((txpd - txpd_offset) / 2) * 10;
	MOVLW       8
	SUBWF       _txpd+0, 0 
	MOVWF       R3 
	MOVLW       0
	SUBWFB      _txpd+1, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVF        R0, 0 
	SUBLW       255
	MOVWF       R3 
	MOVF        R1, 0 
	MOVWF       R4 
	MOVLW       255
	SUBFWB      R4, 1 
	MOVF        R3, 0 
	MOVWF       _tmp+0 
	MOVF        R4, 0 
	MOVWF       _tmp+1 
;Voodoo_V1.c,314 :: 		txpdh = tmp >> 8;
	MOVF        R4, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       _txpdh+0 
;Voodoo_V1.c,315 :: 		txpdl = tmp - (txpdh << 8);
	MOVF        R3, 0 
	MOVWF       _txpdl+0 
;Voodoo_V1.c,316 :: 		}
L_end_calc_txpd:
	RETURN      0
; end of _calc_txpd

_calc_main_dly:

;Voodoo_V1.c,318 :: 		void calc_main_dly() {                           // Calculate main sample delay
;Voodoo_V1.c,319 :: 		tmp = 65535 - ((main_dly - main_dly_offset) / 2) * 10;
	MOVLW       5
	SUBWF       _main_dly+0, 0 
	MOVWF       R3 
	MOVLW       0
	MOVWF       R4 
	MOVLW       0
	SUBFWB      R4, 1 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	BTFSC       R1, 6 
	BSF         R1, 7 
	BTFSS       R1, 7 
	GOTO        L__calc_main_dly261
	BTFSS       STATUS+0, 0 
	GOTO        L__calc_main_dly261
	INFSNZ      R0, 1 
	INCF        R1, 1 
L__calc_main_dly261:
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVF        R0, 0 
	SUBLW       255
	MOVWF       R3 
	MOVF        R1, 0 
	MOVWF       R4 
	MOVLW       255
	SUBFWB      R4, 1 
	MOVF        R3, 0 
	MOVWF       _tmp+0 
	MOVF        R4, 0 
	MOVWF       _tmp+1 
;Voodoo_V1.c,320 :: 		main_dlyh = tmp >> 8;
	MOVF        R4, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       _main_dlyh+0 
;Voodoo_V1.c,321 :: 		main_dlyl = tmp - (main_dlyh << 8);
	MOVF        R3, 0 
	MOVWF       _main_dlyl+0 
;Voodoo_V1.c,322 :: 		}
L_end_calc_main_dly:
	RETURN      0
; end of _calc_main_dly

_calc_main_smpl:

;Voodoo_V1.c,324 :: 		void calc_main_smpl() {                          // Calculate main sample pulse width
;Voodoo_V1.c,325 :: 		tmp = 65535 - ((main_smpl - main_smpl_offset) / 2) * 10;
	MOVLW       4
	SUBWF       _main_smpl+0, 0 
	MOVWF       R3 
	MOVLW       0
	MOVWF       R4 
	MOVLW       0
	SUBFWB      R4, 1 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	BTFSC       R1, 6 
	BSF         R1, 7 
	BTFSS       R1, 7 
	GOTO        L__calc_main_smpl263
	BTFSS       STATUS+0, 0 
	GOTO        L__calc_main_smpl263
	INFSNZ      R0, 1 
	INCF        R1, 1 
L__calc_main_smpl263:
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVF        R0, 0 
	SUBLW       255
	MOVWF       R3 
	MOVF        R1, 0 
	MOVWF       R4 
	MOVLW       255
	SUBFWB      R4, 1 
	MOVF        R3, 0 
	MOVWF       _tmp+0 
	MOVF        R4, 0 
	MOVWF       _tmp+1 
;Voodoo_V1.c,326 :: 		main_smplh = tmp >> 8;
	MOVF        R4, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       _main_smplh+0 
;Voodoo_V1.c,327 :: 		main_smpll = tmp - (main_smplh << 8);
	MOVF        R3, 0 
	MOVWF       _main_smpll+0 
;Voodoo_V1.c,328 :: 		}
L_end_calc_main_smpl:
	RETURN      0
; end of _calc_main_smpl

_calc_efe_dly:

;Voodoo_V1.c,330 :: 		void calc_efe_dly() {                            // Calculate EFE sample delay
;Voodoo_V1.c,331 :: 		tmp = 65535 - ((efe_dly - efe_dly_offset) / 2) * 10;
	MOVLW       10
	SUBWF       _efe_dly+0, 0 
	MOVWF       R3 
	MOVLW       0
	SUBWFB      _efe_dly+1, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVF        R0, 0 
	SUBLW       255
	MOVWF       R3 
	MOVF        R1, 0 
	MOVWF       R4 
	MOVLW       255
	SUBFWB      R4, 1 
	MOVF        R3, 0 
	MOVWF       _tmp+0 
	MOVF        R4, 0 
	MOVWF       _tmp+1 
;Voodoo_V1.c,332 :: 		efe_dlyh = tmp >> 8;
	MOVF        R4, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       _efe_dlyh+0 
;Voodoo_V1.c,333 :: 		efe_dlyl = tmp - (efe_dlyh << 8);
	MOVF        R3, 0 
	MOVWF       _efe_dlyl+0 
;Voodoo_V1.c,334 :: 		}
L_end_calc_efe_dly:
	RETURN      0
; end of _calc_efe_dly

_calc_efe_smpl:

;Voodoo_V1.c,336 :: 		void calc_efe_smpl() {                           // Calculate EFE sample pulse width
;Voodoo_V1.c,337 :: 		efe_smplh = main_smplh;                        // EFE sample pulse width must equal main sample
	MOVF        _main_smplh+0, 0 
	MOVWF       _efe_smplh+0 
;Voodoo_V1.c,338 :: 		efe_smpll = main_smpll;
	MOVF        _main_smpll+0, 0 
	MOVWF       _efe_smpll+0 
;Voodoo_V1.c,339 :: 		}
L_end_calc_efe_smpl:
	RETURN      0
; end of _calc_efe_smpl

_calc_disc_dly:

;Voodoo_V1.c,341 :: 		void calc_disc_dly() {                           // Calculate disc sample delay
;Voodoo_V1.c,342 :: 		tmp = 65535 - ((disc_dly - disc_dly_offset) / 2) * 10;
	MOVLW       9
	SUBWF       _disc_dly+0, 0 
	MOVWF       R3 
	MOVLW       0
	MOVWF       R4 
	MOVLW       0
	SUBFWB      R4, 1 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	BTFSC       R1, 6 
	BSF         R1, 7 
	BTFSS       R1, 7 
	GOTO        L__calc_disc_dly267
	BTFSS       STATUS+0, 0 
	GOTO        L__calc_disc_dly267
	INFSNZ      R0, 1 
	INCF        R1, 1 
L__calc_disc_dly267:
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVF        R0, 0 
	SUBLW       255
	MOVWF       R3 
	MOVF        R1, 0 
	MOVWF       R4 
	MOVLW       255
	SUBFWB      R4, 1 
	MOVF        R3, 0 
	MOVWF       _tmp+0 
	MOVF        R4, 0 
	MOVWF       _tmp+1 
;Voodoo_V1.c,343 :: 		disc_dlyh = tmp >> 8;
	MOVF        R4, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       _disc_dlyh+0 
;Voodoo_V1.c,344 :: 		disc_dlyl = tmp - (disc_dlyh << 8);
	MOVF        R3, 0 
	MOVWF       _disc_dlyl+0 
;Voodoo_V1.c,345 :: 		}
L_end_calc_disc_dly:
	RETURN      0
; end of _calc_disc_dly

_calc_disc_smpl:

;Voodoo_V1.c,347 :: 		void calc_disc_smpl() {                          // Calculate disc sample pulse width
;Voodoo_V1.c,348 :: 		tmp = 65535 - ((disc_smpl - disc_smpl_offset) / 2) * 10;
	MOVLW       6
	SUBWF       _disc_smpl+0, 0 
	MOVWF       R3 
	MOVLW       0
	MOVWF       R4 
	MOVLW       0
	SUBFWB      R4, 1 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	BTFSC       R1, 6 
	BSF         R1, 7 
	BTFSS       R1, 7 
	GOTO        L__calc_disc_smpl269
	BTFSS       STATUS+0, 0 
	GOTO        L__calc_disc_smpl269
	INFSNZ      R0, 1 
	INCF        R1, 1 
L__calc_disc_smpl269:
	MOVLW       10
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVF        R0, 0 
	SUBLW       255
	MOVWF       R3 
	MOVF        R1, 0 
	MOVWF       R4 
	MOVLW       255
	SUBFWB      R4, 1 
	MOVF        R3, 0 
	MOVWF       _tmp+0 
	MOVF        R4, 0 
	MOVWF       _tmp+1 
;Voodoo_V1.c,349 :: 		disc_smplh = tmp >> 8;
	MOVF        R4, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       _disc_smplh+0 
;Voodoo_V1.c,350 :: 		disc_smpll = tmp - (disc_smplh << 8);
	MOVF        R3, 0 
	MOVWF       _disc_smpll+0 
;Voodoo_V1.c,351 :: 		}
L_end_calc_disc_smpl:
	RETURN      0
; end of _calc_disc_smpl

_clear_arrays:

;Voodoo_V1.c,353 :: 		void clear_arrays() {                            // Clear both PI and disc arrays
;Voodoo_V1.c,354 :: 		for (i = 0; i <= (pi_num - 1); i++) {
	CLRF        _i+0 
	CLRF        _i+1 
L_clear_arrays30:
	DECF        _pi_num+0, 0 
	MOVWF       R1 
	CLRF        R2 
	MOVLW       0
	SUBWFB      R2, 1 
	MOVF        _i+1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__clear_arrays271
	MOVF        _i+0, 0 
	SUBWF       R1, 0 
L__clear_arrays271:
	BTFSS       STATUS+0, 0 
	GOTO        L_clear_arrays31
;Voodoo_V1.c,355 :: 		pi_array[i] = 0;                             // Clear PI array
	MOVF        _i+0, 0 
	MOVWF       R0 
	MOVF        _i+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _pi_array+0
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       hi_addr(_pi_array+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
;Voodoo_V1.c,356 :: 		disc_array[i] = 0;                           // Clear disc array
	MOVF        _i+0, 0 
	MOVWF       R0 
	MOVF        _i+1, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       _disc_array+0
	ADDWF       R0, 0 
	MOVWF       FSR1L+0 
	MOVLW       hi_addr(_disc_array+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1L+1 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
;Voodoo_V1.c,354 :: 		for (i = 0; i <= (pi_num - 1); i++) {
	INFSNZ      _i+0, 1 
	INCF        _i+1, 1 
;Voodoo_V1.c,357 :: 		}
	GOTO        L_clear_arrays30
L_clear_arrays31:
;Voodoo_V1.c,358 :: 		pi_pointer = 0;                                // Reset PI array pointer
	CLRF        _pi_pointer+0 
;Voodoo_V1.c,359 :: 		pi_total = 0;                                  // Clear PI array total
	CLRF        _pi_total+0 
	CLRF        _pi_total+1 
;Voodoo_V1.c,360 :: 		disc_pointer = 0;                              // Reset disc array pointer
	CLRF        _disc_pointer+0 
;Voodoo_V1.c,361 :: 		disc_total = 0;                                // Clear disc array total;
	CLRF        _disc_total+0 
	CLRF        _disc_total+1 
;Voodoo_V1.c,362 :: 		}
L_end_clear_arrays:
	RETURN      0
; end of _clear_arrays

_write_eeprom:

;Voodoo_V1.c,364 :: 		void write_eeprom() {
;Voodoo_V1.c,365 :: 		EEPROM_Write(0, 0xAA);                         // Initialize EEPROM
	CLRF        FARG_EEPROM_Write_address+0 
	MOVLW       170
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,366 :: 		EEPROM_Write(1, detect_mode);                  // Write detection mode
	MOVLW       1
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _detect_mode+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,367 :: 		tmp = pi_thr >> 8;                             // Extract PI threshold high byte
	MOVF        _pi_thr+1, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       _tmp+0 
	MOVF        R1, 0 
	MOVWF       _tmp+1 
;Voodoo_V1.c,368 :: 		EEPROM_Write(2, tmp);                          // Write PI threshold high byte
	MOVLW       2
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        R0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,369 :: 		tmp = (pi_thr << 8) >> 8;                      // Extract PI threshold low byte
	MOVF        _pi_thr+0, 0 
	MOVWF       R4 
	CLRF        R3 
	MOVF        R4, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       _tmp+0 
	MOVF        R1, 0 
	MOVWF       _tmp+1 
;Voodoo_V1.c,370 :: 		EEPROM_Write(3, tmp);                          // Write PI threshold low byte
	MOVLW       3
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        R0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,371 :: 		EEPROM_Write(4, txon);                         // Write TX pulse width
	MOVLW       4
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _txon+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,372 :: 		tmp = txpd >> 8;                               // Extract TX period high byte
	MOVF        _txpd+1, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       _tmp+0 
	MOVF        R1, 0 
	MOVWF       _tmp+1 
;Voodoo_V1.c,373 :: 		EEPROM_Write(5, tmp);                          // Write TX period high byte
	MOVLW       5
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        R0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,374 :: 		tmp = (txpd << 8) >> 8;                        // Extract TX period low byte
	MOVF        _txpd+0, 0 
	MOVWF       R4 
	CLRF        R3 
	MOVF        R4, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       _tmp+0 
	MOVF        R1, 0 
	MOVWF       _tmp+1 
;Voodoo_V1.c,375 :: 		EEPROM_Write(6, tmp);                          // Write TX period low byte
	MOVLW       6
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        R0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,376 :: 		EEPROM_Write(7, main_dly);                     // Write main sample delay
	MOVLW       7
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _main_dly+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,377 :: 		EEPROM_Write(8, main_smpl);                    // Write main sample pulse width
	MOVLW       8
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _main_smpl+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,378 :: 		tmp = efe_dly >> 8;                            // Extract EFE sample delay high byte
	MOVF        _efe_dly+1, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       _tmp+0 
	MOVF        R1, 0 
	MOVWF       _tmp+1 
;Voodoo_V1.c,379 :: 		EEPROM_Write(9, tmp);                          // Write EFE sample delay high byte
	MOVLW       9
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        R0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,380 :: 		tmp = (efe_dly << 8) >> 8;                     // Extract EFE sample delay low byte
	MOVF        _efe_dly+0, 0 
	MOVWF       R4 
	CLRF        R3 
	MOVF        R4, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       _tmp+0 
	MOVF        R1, 0 
	MOVWF       _tmp+1 
;Voodoo_V1.c,381 :: 		EEPROM_Write(10, tmp);                         // Write EFE sample delay low byte
	MOVLW       10
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        R0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,382 :: 		EEPROM_Write(11, pi_num);                      // Write number of PI readings to average
	MOVLW       11
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _pi_num+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,383 :: 		tmp = disc_thr >> 8;                           // Extract disc threshold high byte
	MOVF        _disc_thr+1, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       _tmp+0 
	MOVF        R1, 0 
	MOVWF       _tmp+1 
;Voodoo_V1.c,384 :: 		EEPROM_Write(12, tmp);                         // Write disc threshold high byte
	MOVLW       12
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        R0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,385 :: 		tmp = (disc_thr << 8) >> 8;                    // Extract disc threshold low byte
	MOVF        _disc_thr+0, 0 
	MOVWF       R4 
	CLRF        R3 
	MOVF        R4, 0 
	MOVWF       R0 
	CLRF        R1 
	MOVF        R0, 0 
	MOVWF       _tmp+0 
	MOVF        R1, 0 
	MOVWF       _tmp+1 
;Voodoo_V1.c,386 :: 		EEPROM_Write(13, tmp);                         // Write disc threshold low byte
	MOVLW       13
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        R0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,387 :: 		EEPROM_Write(14, disc_dly);                    // Write disc sample delay
	MOVLW       14
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _disc_dly+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,388 :: 		EEPROM_Write(15, disc_smpl);                   // Write disc sample pulse width
	MOVLW       15
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _disc_smpl+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,389 :: 		EEPROM_Write(16, disc_num);                    // Write number of disc readings to average
	MOVLW       16
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _disc_num+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,390 :: 		EEPROM_Write(17, meter_zero_limit);            // Write meter zero limit
	MOVLW       17
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _meter_zero_limit+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,391 :: 		EEPROM_Write(18, counter_limit);               // Write accept and reject counter limit
	MOVLW       18
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _counter_limit+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,392 :: 		}
L_end_write_eeprom:
	RETURN      0
; end of _write_eeprom

_scan_keypad:

;Voodoo_V1.c,395 :: 		char scan_keypad() {
;Voodoo_V1.c,396 :: 		result = 0;
	CLRF        _result+0 
;Voodoo_V1.c,397 :: 		if (menu_btn_port == btn_on) {                 // Check menu button
	BTFSC       PORTC+0, 6 
	GOTO        L_scan_keypad33
;Voodoo_V1.c,398 :: 		result = menu_btn;
	MOVLW       1
	MOVWF       _result+0 
;Voodoo_V1.c,399 :: 		Delay_ms(debounce);
	MOVLW       3
	MOVWF       R11, 0
	MOVLW       138
	MOVWF       R12, 0
	MOVLW       85
	MOVWF       R13, 0
L_scan_keypad34:
	DECFSZ      R13, 1, 1
	BRA         L_scan_keypad34
	DECFSZ      R12, 1, 1
	BRA         L_scan_keypad34
	DECFSZ      R11, 1, 1
	BRA         L_scan_keypad34
	NOP
	NOP
;Voodoo_V1.c,400 :: 		while (menu_btn_port == btn_on) {}
L_scan_keypad35:
	BTFSC       PORTC+0, 6 
	GOTO        L_scan_keypad36
	GOTO        L_scan_keypad35
L_scan_keypad36:
;Voodoo_V1.c,401 :: 		Delay_ms(debounce);
	MOVLW       3
	MOVWF       R11, 0
	MOVLW       138
	MOVWF       R12, 0
	MOVLW       85
	MOVWF       R13, 0
L_scan_keypad37:
	DECFSZ      R13, 1, 1
	BRA         L_scan_keypad37
	DECFSZ      R12, 1, 1
	BRA         L_scan_keypad37
	DECFSZ      R11, 1, 1
	BRA         L_scan_keypad37
	NOP
	NOP
;Voodoo_V1.c,402 :: 		} else {
	GOTO        L_scan_keypad38
L_scan_keypad33:
;Voodoo_V1.c,403 :: 		if (up_btn_port == btn_on) {                 // Check up button
	BTFSC       PORTC+0, 5 
	GOTO        L_scan_keypad39
;Voodoo_V1.c,404 :: 		result = up_btn;
	MOVLW       2
	MOVWF       _result+0 
;Voodoo_V1.c,405 :: 		Delay_ms(debounce);
	MOVLW       3
	MOVWF       R11, 0
	MOVLW       138
	MOVWF       R12, 0
	MOVLW       85
	MOVWF       R13, 0
L_scan_keypad40:
	DECFSZ      R13, 1, 1
	BRA         L_scan_keypad40
	DECFSZ      R12, 1, 1
	BRA         L_scan_keypad40
	DECFSZ      R11, 1, 1
	BRA         L_scan_keypad40
	NOP
	NOP
;Voodoo_V1.c,406 :: 		while (up_btn_port == btn_on) {}
L_scan_keypad41:
	BTFSC       PORTC+0, 5 
	GOTO        L_scan_keypad42
	GOTO        L_scan_keypad41
L_scan_keypad42:
;Voodoo_V1.c,407 :: 		Delay_ms(debounce);
	MOVLW       3
	MOVWF       R11, 0
	MOVLW       138
	MOVWF       R12, 0
	MOVLW       85
	MOVWF       R13, 0
L_scan_keypad43:
	DECFSZ      R13, 1, 1
	BRA         L_scan_keypad43
	DECFSZ      R12, 1, 1
	BRA         L_scan_keypad43
	DECFSZ      R11, 1, 1
	BRA         L_scan_keypad43
	NOP
	NOP
;Voodoo_V1.c,408 :: 		} else {
	GOTO        L_scan_keypad44
L_scan_keypad39:
;Voodoo_V1.c,409 :: 		if (down_btn_port == btn_on) {             // Check down button
	BTFSC       PORTC+0, 4 
	GOTO        L_scan_keypad45
;Voodoo_V1.c,410 :: 		result = down_btn;
	MOVLW       3
	MOVWF       _result+0 
;Voodoo_V1.c,411 :: 		Delay_ms(debounce);
	MOVLW       3
	MOVWF       R11, 0
	MOVLW       138
	MOVWF       R12, 0
	MOVLW       85
	MOVWF       R13, 0
L_scan_keypad46:
	DECFSZ      R13, 1, 1
	BRA         L_scan_keypad46
	DECFSZ      R12, 1, 1
	BRA         L_scan_keypad46
	DECFSZ      R11, 1, 1
	BRA         L_scan_keypad46
	NOP
	NOP
;Voodoo_V1.c,412 :: 		while (down_btn_port == btn_on) {}
L_scan_keypad47:
	BTFSC       PORTC+0, 4 
	GOTO        L_scan_keypad48
	GOTO        L_scan_keypad47
L_scan_keypad48:
;Voodoo_V1.c,413 :: 		Delay_ms(debounce);
	MOVLW       3
	MOVWF       R11, 0
	MOVLW       138
	MOVWF       R12, 0
	MOVLW       85
	MOVWF       R13, 0
L_scan_keypad49:
	DECFSZ      R13, 1, 1
	BRA         L_scan_keypad49
	DECFSZ      R12, 1, 1
	BRA         L_scan_keypad49
	DECFSZ      R11, 1, 1
	BRA         L_scan_keypad49
	NOP
	NOP
;Voodoo_V1.c,414 :: 		} else {
	GOTO        L_scan_keypad50
L_scan_keypad45:
;Voodoo_V1.c,415 :: 		if (enter_btn_port == btn_on) {          // Check enter button
	BTFSC       PORTD+0, 3 
	GOTO        L_scan_keypad51
;Voodoo_V1.c,416 :: 		result = enter_btn;
	MOVLW       4
	MOVWF       _result+0 
;Voodoo_V1.c,417 :: 		Delay_ms(debounce);
	MOVLW       3
	MOVWF       R11, 0
	MOVLW       138
	MOVWF       R12, 0
	MOVLW       85
	MOVWF       R13, 0
L_scan_keypad52:
	DECFSZ      R13, 1, 1
	BRA         L_scan_keypad52
	DECFSZ      R12, 1, 1
	BRA         L_scan_keypad52
	DECFSZ      R11, 1, 1
	BRA         L_scan_keypad52
	NOP
	NOP
;Voodoo_V1.c,418 :: 		while (enter_btn_port == btn_on) {}
L_scan_keypad53:
	BTFSC       PORTD+0, 3 
	GOTO        L_scan_keypad54
	GOTO        L_scan_keypad53
L_scan_keypad54:
;Voodoo_V1.c,419 :: 		Delay_ms(debounce);
	MOVLW       3
	MOVWF       R11, 0
	MOVLW       138
	MOVWF       R12, 0
	MOVLW       85
	MOVWF       R13, 0
L_scan_keypad55:
	DECFSZ      R13, 1, 1
	BRA         L_scan_keypad55
	DECFSZ      R12, 1, 1
	BRA         L_scan_keypad55
	DECFSZ      R11, 1, 1
	BRA         L_scan_keypad55
	NOP
	NOP
;Voodoo_V1.c,420 :: 		}
L_scan_keypad51:
;Voodoo_V1.c,421 :: 		}
L_scan_keypad50:
;Voodoo_V1.c,422 :: 		}
L_scan_keypad44:
;Voodoo_V1.c,423 :: 		}
L_scan_keypad38:
;Voodoo_V1.c,424 :: 		return result;
	MOVF        _result+0, 0 
	MOVWF       R0 
;Voodoo_V1.c,425 :: 		}
L_end_scan_keypad:
	RETURN      0
; end of _scan_keypad

_menu_system:

;Voodoo_V1.c,428 :: 		void menu_system() {
;Voodoo_V1.c,429 :: 		PIE1 = 0x00;                                   // Disable TMR1 interrupt
	CLRF        PIE1+0 
;Voodoo_V1.c,430 :: 		INTCON = 0x00;                                 // Disable global, peripheral and TMR0 interrupts
	CLRF        INTCON+0 
;Voodoo_V1.c,431 :: 		menu_flag = menu_active;                       // Flag menu system as active
	MOVLW       1
	MOVWF       _menu_flag+0 
;Voodoo_V1.c,432 :: 		EN1 = EN1_off;                                 // Turn off MOSFET to save power
	BCF         LATD6_bit+0, BitPos(LATD6_bit+0) 
;Voodoo_V1.c,433 :: 		audio_en = audio_off;                          // Disable audio while in menu system
	BCF         LATA4_bit+0, BitPos(LATA4_bit+0) 
;Voodoo_V1.c,434 :: 		menu_disp = 0;                                 // Set menu display to first screen
	CLRF        _menu_disp+0 
;Voodoo_V1.c,435 :: 		while (menu_flag == menu_active) {             // Enter menu system
L_menu_system56:
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system275
	MOVLW       1
	XORWF       _menu_flag+0, 0 
L__menu_system275:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system57
;Voodoo_V1.c,436 :: 		switch (menu_disp) {
	GOTO        L_menu_system58
;Voodoo_V1.c,437 :: 		case 0:
L_menu_system60:
;Voodoo_V1.c,438 :: 		Lcd_Out(1, 1, " DETECTING MODE ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr4_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr4_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,439 :: 		if (detect_mode == pulse) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system276
	MOVLW       0
	XORWF       _detect_mode+0, 0 
L__menu_system276:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system61
;Voodoo_V1.c,440 :: 		Lcd_Out(2, 1, "     PULSE      ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr5_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr5_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,441 :: 		} else {
	GOTO        L_menu_system62
L_menu_system61:
;Voodoo_V1.c,442 :: 		Lcd_Out(2, 1, "     HYBRID     ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr6_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr6_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,443 :: 		}
L_menu_system62:
;Voodoo_V1.c,444 :: 		if ((keypad_btn == up_btn) || (keypad_btn == down_btn)) { // Toggle detection mode
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system277
	MOVLW       2
	XORWF       _keypad_btn+0, 0 
L__menu_system277:
	BTFSC       STATUS+0, 2 
	GOTO        L__menu_system242
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system278
	MOVLW       3
	XORWF       _keypad_btn+0, 0 
L__menu_system278:
	BTFSC       STATUS+0, 2 
	GOTO        L__menu_system242
	GOTO        L_menu_system65
L__menu_system242:
;Voodoo_V1.c,445 :: 		if (detect_mode == pulse) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system279
	MOVLW       0
	XORWF       _detect_mode+0, 0 
L__menu_system279:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system66
;Voodoo_V1.c,446 :: 		detect_mode = hybrid;
	MOVLW       1
	MOVWF       _detect_mode+0 
;Voodoo_V1.c,447 :: 		} else {
	GOTO        L_menu_system67
L_menu_system66:
;Voodoo_V1.c,448 :: 		detect_mode = pulse;
	CLRF        _detect_mode+0 
;Voodoo_V1.c,449 :: 		}
L_menu_system67:
;Voodoo_V1.c,450 :: 		}
L_menu_system65:
;Voodoo_V1.c,451 :: 		break;
	GOTO        L_menu_system59
;Voodoo_V1.c,452 :: 		case 1:
L_menu_system68:
;Voodoo_V1.c,453 :: 		Lcd_Out(1, 1, "  PI THRESHOLD  ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr7_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr7_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,454 :: 		Lcd_Out(2, 1, "       ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr8_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr8_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,455 :: 		thr_disp = pi_thr - 511;
	MOVLW       255
	SUBWF       _pi_thr+0, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	MOVWF       _thr_disp+0 
;Voodoo_V1.c,456 :: 		extract_and_disp(thr_disp, 10, 2, 8);
	MOVF        R0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       10
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       8
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,457 :: 		extract_and_disp(thr_disp, 1, 2, 9);
	MOVF        _thr_disp+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       1
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       9
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,458 :: 		Lcd_Out(2, 10, "       ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       10
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr9_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr9_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,459 :: 		if (keypad_btn == up_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system280
	MOVLW       2
	XORWF       _keypad_btn+0, 0 
L__menu_system280:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system69
;Voodoo_V1.c,460 :: 		pi_thr++;
	INFSNZ      _pi_thr+0, 1 
	INCF        _pi_thr+1, 1 
;Voodoo_V1.c,461 :: 		if (pi_thr > 531) {pi_thr = 531;}
	MOVF        _pi_thr+1, 0 
	SUBLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system281
	MOVF        _pi_thr+0, 0 
	SUBLW       19
L__menu_system281:
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system70
	MOVLW       19
	MOVWF       _pi_thr+0 
	MOVLW       2
	MOVWF       _pi_thr+1 
L_menu_system70:
;Voodoo_V1.c,462 :: 		}
L_menu_system69:
;Voodoo_V1.c,463 :: 		if (keypad_btn == down_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system282
	MOVLW       3
	XORWF       _keypad_btn+0, 0 
L__menu_system282:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system71
;Voodoo_V1.c,464 :: 		pi_thr--;
	MOVLW       1
	SUBWF       _pi_thr+0, 1 
	MOVLW       0
	SUBWFB      _pi_thr+1, 1 
;Voodoo_V1.c,465 :: 		if (pi_thr < 511) {pi_thr = 511;}
	MOVLW       1
	SUBWF       _pi_thr+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system283
	MOVLW       255
	SUBWF       _pi_thr+0, 0 
L__menu_system283:
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system72
	MOVLW       255
	MOVWF       _pi_thr+0 
	MOVLW       1
	MOVWF       _pi_thr+1 
L_menu_system72:
;Voodoo_V1.c,466 :: 		}
L_menu_system71:
;Voodoo_V1.c,467 :: 		break;
	GOTO        L_menu_system59
;Voodoo_V1.c,468 :: 		case 2:
L_menu_system73:
;Voodoo_V1.c,469 :: 		Lcd_Out(1, 1, " PI PULSE WIDTH ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr10_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr10_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,470 :: 		Lcd_Out(2, 1, "     ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr11_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr11_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,471 :: 		extract_and_disp(txon, 100, 2, 6);
	MOVF        _txon+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       100
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       6
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,472 :: 		extract_and_disp(txon, 10, 2, 7);
	MOVF        _txon+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       10
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       7
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,473 :: 		extract_and_disp(txon, 1, 2, 8);
	MOVF        _txon+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       1
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       8
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,474 :: 		Lcd_Out(2, 9, "us      ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       9
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr12_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr12_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,475 :: 		if (keypad_btn == up_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system284
	MOVLW       2
	XORWF       _keypad_btn+0, 0 
L__menu_system284:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system74
;Voodoo_V1.c,476 :: 		txon += 10;
	MOVLW       10
	ADDWF       _txon+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       _txon+0 
;Voodoo_V1.c,477 :: 		if (txon > 200) {txon = 200;}
	MOVF        R1, 0 
	SUBLW       200
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system75
	MOVLW       200
	MOVWF       _txon+0 
L_menu_system75:
;Voodoo_V1.c,478 :: 		}
L_menu_system74:
;Voodoo_V1.c,479 :: 		if (keypad_btn == down_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system285
	MOVLW       3
	XORWF       _keypad_btn+0, 0 
L__menu_system285:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system76
;Voodoo_V1.c,480 :: 		txon -= 10;
	MOVLW       10
	SUBWF       _txon+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       _txon+0 
;Voodoo_V1.c,481 :: 		if (txon < 10) {txon = 10;}
	MOVLW       10
	SUBWF       R1, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system77
	MOVLW       10
	MOVWF       _txon+0 
L_menu_system77:
;Voodoo_V1.c,482 :: 		}
L_menu_system76:
;Voodoo_V1.c,483 :: 		break;
	GOTO        L_menu_system59
;Voodoo_V1.c,484 :: 		case 3:
L_menu_system78:
;Voodoo_V1.c,485 :: 		Lcd_Out(1, 1, "PI SAMPLE DELAY ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr13_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr13_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,486 :: 		Lcd_Out(2, 1, "      ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr14_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr14_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,487 :: 		extract_and_disp(main_dly, 10, 2, 7);
	MOVF        _main_dly+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       10
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       7
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,488 :: 		extract_and_disp(main_dly, 1, 2, 8);
	MOVF        _main_dly+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       1
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       8
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,489 :: 		Lcd_Out(2, 9, "us      ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       9
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr15_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr15_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,490 :: 		if (keypad_btn == up_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system286
	MOVLW       2
	XORWF       _keypad_btn+0, 0 
L__menu_system286:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system79
;Voodoo_V1.c,491 :: 		main_dly++;
	INCF        _main_dly+0, 1 
;Voodoo_V1.c,492 :: 		if (main_dly > 60) {main_dly = 60;}
	MOVF        _main_dly+0, 0 
	SUBLW       60
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system80
	MOVLW       60
	MOVWF       _main_dly+0 
L_menu_system80:
;Voodoo_V1.c,493 :: 		}
L_menu_system79:
;Voodoo_V1.c,494 :: 		if (keypad_btn == down_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system287
	MOVLW       3
	XORWF       _keypad_btn+0, 0 
L__menu_system287:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system81
;Voodoo_V1.c,495 :: 		main_dly--;
	DECF        _main_dly+0, 1 
;Voodoo_V1.c,496 :: 		if (main_dly < 10) {main_dly = 10;}
	MOVLW       10
	SUBWF       _main_dly+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system82
	MOVLW       10
	MOVWF       _main_dly+0 
L_menu_system82:
;Voodoo_V1.c,497 :: 		}
L_menu_system81:
;Voodoo_V1.c,498 :: 		break;
	GOTO        L_menu_system59
;Voodoo_V1.c,499 :: 		case 4:
L_menu_system83:
;Voodoo_V1.c,500 :: 		Lcd_Out(1, 1, "PI SAMPLE WIDTH ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr16_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr16_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,501 :: 		Lcd_Out(2, 1, "     ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr17_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr17_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,502 :: 		extract_and_disp(main_smpl, 100, 2, 6);
	MOVF        _main_smpl+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       100
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       6
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,503 :: 		extract_and_disp(main_smpl, 10, 2, 7);
	MOVF        _main_smpl+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       10
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       7
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,504 :: 		extract_and_disp(main_smpl, 1, 2, 8);
	MOVF        _main_smpl+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       1
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       8
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,505 :: 		Lcd_Out(2, 9, "us      ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       9
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr18_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr18_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,506 :: 		if (keypad_btn == up_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system288
	MOVLW       2
	XORWF       _keypad_btn+0, 0 
L__menu_system288:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system84
;Voodoo_V1.c,507 :: 		main_smpl++;
	INCF        _main_smpl+0, 1 
;Voodoo_V1.c,508 :: 		if (main_smpl > 60) {main_smpl = 60;}
	MOVF        _main_smpl+0, 0 
	SUBLW       60
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system85
	MOVLW       60
	MOVWF       _main_smpl+0 
L_menu_system85:
;Voodoo_V1.c,509 :: 		}
L_menu_system84:
;Voodoo_V1.c,510 :: 		if (keypad_btn == down_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system289
	MOVLW       3
	XORWF       _keypad_btn+0, 0 
L__menu_system289:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system86
;Voodoo_V1.c,511 :: 		main_smpl--;
	DECF        _main_smpl+0, 1 
;Voodoo_V1.c,512 :: 		if (main_smpl < 20) {main_smpl = 20;}
	MOVLW       20
	SUBWF       _main_smpl+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system87
	MOVLW       20
	MOVWF       _main_smpl+0 
L_menu_system87:
;Voodoo_V1.c,513 :: 		}
L_menu_system86:
;Voodoo_V1.c,514 :: 		break;
	GOTO        L_menu_system59
;Voodoo_V1.c,515 :: 		case 5:
L_menu_system88:
;Voodoo_V1.c,516 :: 		Lcd_Out(1, 1, "   PI AVERAGE   ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr19_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr19_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,517 :: 		Lcd_Out(2, 1, "       ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr20_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr20_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,518 :: 		extract_and_disp(pi_num, 10, 2, 8);
	MOVF        _pi_num+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       10
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       8
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,519 :: 		extract_and_disp(pi_num, 1, 2, 9);
	MOVF        _pi_num+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       1
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       9
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,520 :: 		Lcd_Out(2, 10, "       ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       10
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr21_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr21_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,521 :: 		if (keypad_btn == up_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system290
	MOVLW       2
	XORWF       _keypad_btn+0, 0 
L__menu_system290:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system89
;Voodoo_V1.c,522 :: 		pi_num++;
	INCF        _pi_num+0, 1 
;Voodoo_V1.c,523 :: 		if (pi_num > 64) {pi_num = 64;}
	MOVF        _pi_num+0, 0 
	SUBLW       64
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system90
	MOVLW       64
	MOVWF       _pi_num+0 
L_menu_system90:
;Voodoo_V1.c,524 :: 		}
L_menu_system89:
;Voodoo_V1.c,525 :: 		if (keypad_btn == down_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system291
	MOVLW       3
	XORWF       _keypad_btn+0, 0 
L__menu_system291:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system91
;Voodoo_V1.c,526 :: 		pi_num--;
	DECF        _pi_num+0, 1 
;Voodoo_V1.c,527 :: 		if (pi_num < 1) {pi_num = 1;}
	MOVLW       1
	SUBWF       _pi_num+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system92
	MOVLW       1
	MOVWF       _pi_num+0 
L_menu_system92:
;Voodoo_V1.c,528 :: 		}
L_menu_system91:
;Voodoo_V1.c,529 :: 		break;
	GOTO        L_menu_system59
;Voodoo_V1.c,530 :: 		case 6:
L_menu_system93:
;Voodoo_V1.c,531 :: 		Lcd_Out(1, 1, " DISC THRESHOLD ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr22_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr22_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,532 :: 		Lcd_Out(2, 1, "       ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr23_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr23_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,533 :: 		thr_disp = disc_thr - 511;
	MOVLW       255
	SUBWF       _disc_thr+0, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	MOVWF       _thr_disp+0 
;Voodoo_V1.c,534 :: 		extract_and_disp(thr_disp, 10, 2, 8);
	MOVF        R0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       10
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       8
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,535 :: 		extract_and_disp(thr_disp, 1, 2, 9);
	MOVF        _thr_disp+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       1
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       9
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,536 :: 		Lcd_Out(2, 10, "       ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       10
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr24_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr24_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,537 :: 		if (keypad_btn == up_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system292
	MOVLW       2
	XORWF       _keypad_btn+0, 0 
L__menu_system292:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system94
;Voodoo_V1.c,538 :: 		disc_thr++;
	INFSNZ      _disc_thr+0, 1 
	INCF        _disc_thr+1, 1 
;Voodoo_V1.c,539 :: 		if (disc_thr > 531) {disc_thr = 531;}
	MOVF        _disc_thr+1, 0 
	SUBLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system293
	MOVF        _disc_thr+0, 0 
	SUBLW       19
L__menu_system293:
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system95
	MOVLW       19
	MOVWF       _disc_thr+0 
	MOVLW       2
	MOVWF       _disc_thr+1 
L_menu_system95:
;Voodoo_V1.c,540 :: 		}
L_menu_system94:
;Voodoo_V1.c,541 :: 		if (keypad_btn == down_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system294
	MOVLW       3
	XORWF       _keypad_btn+0, 0 
L__menu_system294:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system96
;Voodoo_V1.c,542 :: 		disc_thr--;
	MOVLW       1
	SUBWF       _disc_thr+0, 1 
	MOVLW       0
	SUBWFB      _disc_thr+1, 1 
;Voodoo_V1.c,543 :: 		if (disc_thr < 511) {disc_thr = 511;}
	MOVLW       1
	SUBWF       _disc_thr+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system295
	MOVLW       255
	SUBWF       _disc_thr+0, 0 
L__menu_system295:
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system97
	MOVLW       255
	MOVWF       _disc_thr+0 
	MOVLW       1
	MOVWF       _disc_thr+1 
L_menu_system97:
;Voodoo_V1.c,544 :: 		}
L_menu_system96:
;Voodoo_V1.c,545 :: 		break;
	GOTO        L_menu_system59
;Voodoo_V1.c,546 :: 		case 7:
L_menu_system98:
;Voodoo_V1.c,547 :: 		Lcd_Out(1, 1, "DISC SMPL DELAY ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr25_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr25_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,548 :: 		Lcd_Out(2, 1, "     ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr26_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr26_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,549 :: 		extract_and_disp(disc_dly, 100, 2, 6);
	MOVF        _disc_dly+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       100
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       6
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,550 :: 		extract_and_disp(disc_dly, 10, 2, 7);
	MOVF        _disc_dly+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       10
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       7
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,551 :: 		extract_and_disp(disc_dly, 1, 2, 8);
	MOVF        _disc_dly+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       1
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       8
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,552 :: 		Lcd_Out(2, 9, "us      ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       9
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr27_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr27_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,553 :: 		if (keypad_btn == up_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system296
	MOVLW       2
	XORWF       _keypad_btn+0, 0 
L__menu_system296:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system99
;Voodoo_V1.c,554 :: 		disc_dly++;
	INCF        _disc_dly+0, 1 
;Voodoo_V1.c,555 :: 		if (disc_dly > 100) {disc_dly = 100;}
	MOVF        _disc_dly+0, 0 
	SUBLW       100
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system100
	MOVLW       100
	MOVWF       _disc_dly+0 
L_menu_system100:
;Voodoo_V1.c,556 :: 		}
L_menu_system99:
;Voodoo_V1.c,557 :: 		if (keypad_btn == down_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system297
	MOVLW       3
	XORWF       _keypad_btn+0, 0 
L__menu_system297:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system101
;Voodoo_V1.c,558 :: 		disc_dly--;
	DECF        _disc_dly+0, 1 
;Voodoo_V1.c,559 :: 		if (disc_dly < 20) {disc_dly = 20;}
	MOVLW       20
	SUBWF       _disc_dly+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system102
	MOVLW       20
	MOVWF       _disc_dly+0 
L_menu_system102:
;Voodoo_V1.c,560 :: 		}
L_menu_system101:
;Voodoo_V1.c,561 :: 		break;
	GOTO        L_menu_system59
;Voodoo_V1.c,562 :: 		case 8:
L_menu_system103:
;Voodoo_V1.c,563 :: 		Lcd_Out(1, 1, "DISC SMPL WIDTH ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr28_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr28_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,564 :: 		Lcd_Out(2, 1, "     ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr29_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr29_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,565 :: 		extract_and_disp(disc_smpl, 100, 2, 6);
	MOVF        _disc_smpl+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       100
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       6
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,566 :: 		extract_and_disp(disc_smpl, 10, 2, 7);
	MOVF        _disc_smpl+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       10
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       7
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,567 :: 		extract_and_disp(disc_smpl, 1, 2, 8);
	MOVF        _disc_smpl+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       1
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       8
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,568 :: 		Lcd_Out(2, 9, "us      ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       9
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr30_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr30_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,569 :: 		if (keypad_btn == up_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system298
	MOVLW       2
	XORWF       _keypad_btn+0, 0 
L__menu_system298:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system104
;Voodoo_V1.c,570 :: 		disc_smpl++;
	INCF        _disc_smpl+0, 1 
;Voodoo_V1.c,571 :: 		if (disc_smpl > 100) {main_smpl = 100;}
	MOVF        _disc_smpl+0, 0 
	SUBLW       100
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system105
	MOVLW       100
	MOVWF       _main_smpl+0 
L_menu_system105:
;Voodoo_V1.c,572 :: 		}
L_menu_system104:
;Voodoo_V1.c,573 :: 		if (keypad_btn == down_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system299
	MOVLW       3
	XORWF       _keypad_btn+0, 0 
L__menu_system299:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system106
;Voodoo_V1.c,574 :: 		disc_smpl--;
	DECF        _disc_smpl+0, 1 
;Voodoo_V1.c,575 :: 		if (disc_smpl < 10) {disc_smpl = 10;}
	MOVLW       10
	SUBWF       _disc_smpl+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system107
	MOVLW       10
	MOVWF       _disc_smpl+0 
L_menu_system107:
;Voodoo_V1.c,576 :: 		}
L_menu_system106:
;Voodoo_V1.c,577 :: 		break;
	GOTO        L_menu_system59
;Voodoo_V1.c,578 :: 		case 9:
L_menu_system108:
;Voodoo_V1.c,579 :: 		Lcd_Out(1, 1, "  DISC AVERAGE  ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr31_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr31_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,580 :: 		Lcd_Out(2, 1, "       ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr32_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr32_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,581 :: 		extract_and_disp(disc_num, 10, 2, 8);
	MOVF        _disc_num+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       10
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       8
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,582 :: 		extract_and_disp(disc_num, 1, 2, 9);
	MOVF        _disc_num+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       1
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       9
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,583 :: 		Lcd_Out(2, 10, "       ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       10
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr33_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr33_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,584 :: 		if (keypad_btn == up_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system300
	MOVLW       2
	XORWF       _keypad_btn+0, 0 
L__menu_system300:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system109
;Voodoo_V1.c,585 :: 		disc_num++;
	INCF        _disc_num+0, 1 
;Voodoo_V1.c,586 :: 		if (disc_num > 64) {disc_num = 64;}
	MOVF        _disc_num+0, 0 
	SUBLW       64
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system110
	MOVLW       64
	MOVWF       _disc_num+0 
L_menu_system110:
;Voodoo_V1.c,587 :: 		}
L_menu_system109:
;Voodoo_V1.c,588 :: 		if (keypad_btn == down_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system301
	MOVLW       3
	XORWF       _keypad_btn+0, 0 
L__menu_system301:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system111
;Voodoo_V1.c,589 :: 		disc_num--;
	DECF        _disc_num+0, 1 
;Voodoo_V1.c,590 :: 		if (disc_num < 1) {disc_num = 1;}
	MOVLW       1
	SUBWF       _disc_num+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system112
	MOVLW       1
	MOVWF       _disc_num+0 
L_menu_system112:
;Voodoo_V1.c,591 :: 		}
L_menu_system111:
;Voodoo_V1.c,592 :: 		break;
	GOTO        L_menu_system59
;Voodoo_V1.c,593 :: 		case 10:
L_menu_system113:
;Voodoo_V1.c,594 :: 		Lcd_Out(1, 1, "METER ZERO LIMIT");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr34_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr34_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,595 :: 		Lcd_Out(2, 1, "       ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr35_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr35_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,596 :: 		extract_and_disp(meter_zero_limit, 10, 2, 8);
	MOVF        _meter_zero_limit+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       10
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       8
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,597 :: 		extract_and_disp(meter_zero_limit, 1, 2, 9);
	MOVF        _meter_zero_limit+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       1
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       9
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,598 :: 		Lcd_Out(2, 10, "       ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       10
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr36_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr36_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,599 :: 		if (keypad_btn == up_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system302
	MOVLW       2
	XORWF       _keypad_btn+0, 0 
L__menu_system302:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system114
;Voodoo_V1.c,600 :: 		meter_zero_limit++;
	INCF        _meter_zero_limit+0, 1 
;Voodoo_V1.c,601 :: 		if (meter_zero_limit > 20) {meter_zero_limit = 20;}
	MOVF        _meter_zero_limit+0, 0 
	SUBLW       20
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system115
	MOVLW       20
	MOVWF       _meter_zero_limit+0 
L_menu_system115:
;Voodoo_V1.c,602 :: 		}
L_menu_system114:
;Voodoo_V1.c,603 :: 		if (keypad_btn == down_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system303
	MOVLW       3
	XORWF       _keypad_btn+0, 0 
L__menu_system303:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system116
;Voodoo_V1.c,604 :: 		meter_zero_limit--;
	DECF        _meter_zero_limit+0, 1 
;Voodoo_V1.c,605 :: 		if (meter_zero_limit < 5) {meter_zero_limit = 5;}
	MOVLW       5
	SUBWF       _meter_zero_limit+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system117
	MOVLW       5
	MOVWF       _meter_zero_limit+0 
L_menu_system117:
;Voodoo_V1.c,606 :: 		}
L_menu_system116:
;Voodoo_V1.c,607 :: 		break;
	GOTO        L_menu_system59
;Voodoo_V1.c,608 :: 		case 11:
L_menu_system118:
;Voodoo_V1.c,609 :: 		Lcd_Out(1, 1, " COUNTER LIMIT  ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr37_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr37_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,610 :: 		Lcd_Out(2, 1, "      ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr38_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr38_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,611 :: 		extract_and_disp(counter_limit, 100, 2, 7);
	MOVF        _counter_limit+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       100
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       7
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,612 :: 		extract_and_disp(counter_limit, 10, 2, 8);
	MOVF        _counter_limit+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       10
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       8
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,613 :: 		extract_and_disp(counter_limit, 1, 2, 9);
	MOVF        _counter_limit+0, 0 
	MOVWF       FARG_extract_and_disp_value+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_value+1 
	MOVLW       1
	MOVWF       FARG_extract_and_disp_divisor+0 
	MOVLW       0
	MOVWF       FARG_extract_and_disp_divisor+1 
	MOVLW       2
	MOVWF       FARG_extract_and_disp_row+0 
	MOVLW       9
	MOVWF       FARG_extract_and_disp_col+0 
	CALL        _extract_and_disp+0, 0
;Voodoo_V1.c,614 :: 		Lcd_Out(2, 10, "       ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       10
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr39_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr39_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,615 :: 		if (keypad_btn == up_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system304
	MOVLW       2
	XORWF       _keypad_btn+0, 0 
L__menu_system304:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system119
;Voodoo_V1.c,616 :: 		counter_limit += 10;
	MOVLW       10
	ADDWF       _counter_limit+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       _counter_limit+0 
;Voodoo_V1.c,617 :: 		if (counter_limit > 150) {counter_limit = 150;}
	MOVF        R1, 0 
	SUBLW       150
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system120
	MOVLW       150
	MOVWF       _counter_limit+0 
L_menu_system120:
;Voodoo_V1.c,618 :: 		}
L_menu_system119:
;Voodoo_V1.c,619 :: 		if (keypad_btn == down_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system305
	MOVLW       3
	XORWF       _keypad_btn+0, 0 
L__menu_system305:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system121
;Voodoo_V1.c,620 :: 		counter_limit -= 10;
	MOVLW       10
	SUBWF       _counter_limit+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	MOVWF       _counter_limit+0 
;Voodoo_V1.c,621 :: 		if (counter_limit < 10) {counter_limit = 10;}
	MOVLW       10
	SUBWF       R1, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_menu_system122
	MOVLW       10
	MOVWF       _counter_limit+0 
L_menu_system122:
;Voodoo_V1.c,622 :: 		}
L_menu_system121:
;Voodoo_V1.c,623 :: 		break;
	GOTO        L_menu_system59
;Voodoo_V1.c,624 :: 		}
L_menu_system58:
	MOVF        _menu_disp+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system60
	MOVF        _menu_disp+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system68
	MOVF        _menu_disp+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system73
	MOVF        _menu_disp+0, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system78
	MOVF        _menu_disp+0, 0 
	XORLW       4
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system83
	MOVF        _menu_disp+0, 0 
	XORLW       5
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system88
	MOVF        _menu_disp+0, 0 
	XORLW       6
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system93
	MOVF        _menu_disp+0, 0 
	XORLW       7
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system98
	MOVF        _menu_disp+0, 0 
	XORLW       8
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system103
	MOVF        _menu_disp+0, 0 
	XORLW       9
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system108
	MOVF        _menu_disp+0, 0 
	XORLW       10
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system113
	MOVF        _menu_disp+0, 0 
	XORLW       11
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system118
L_menu_system59:
;Voodoo_V1.c,625 :: 		keypad_btn = scan_keypad();                  // Scan the keypad
	CALL        _scan_keypad+0, 0
	MOVF        R0, 0 
	MOVWF       _keypad_btn+0 
;Voodoo_V1.c,626 :: 		if (keypad_btn == menu_btn) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system306
	MOVLW       1
	XORWF       R0, 0 
L__menu_system306:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system123
;Voodoo_V1.c,627 :: 		menu_flag = menu_inactive;                 // Deactivate menu system if menu button pressed
	CLRF        _menu_flag+0 
;Voodoo_V1.c,628 :: 		write_eeprom();                            // Write data to EEPROM
	CALL        _write_eeprom+0, 0
;Voodoo_V1.c,629 :: 		calc_txon();                               // Calculate TX pulse width and set timer values
	CALL        _calc_txon+0, 0
;Voodoo_V1.c,630 :: 		calc_txpd();                               // Calculate TX period and set timer values
	CALL        _calc_txpd+0, 0
;Voodoo_V1.c,631 :: 		calc_main_dly();                           // Calculate main sample delay and set timer values
	CALL        _calc_main_dly+0, 0
;Voodoo_V1.c,632 :: 		calc_main_smpl();                          // Calculate main sample pulse width and set timer values
	CALL        _calc_main_smpl+0, 0
;Voodoo_V1.c,633 :: 		calc_efe_dly();                            // Calculate EFE sample delay and set timer values
	CALL        _calc_efe_dly+0, 0
;Voodoo_V1.c,634 :: 		calc_efe_smpl();                           // Calculate EFE sample pulse width and set timer values
	CALL        _calc_efe_smpl+0, 0
;Voodoo_V1.c,635 :: 		calc_disc_dly();                           // Calculate disc sample delay and set timer values
	CALL        _calc_disc_dly+0, 0
;Voodoo_V1.c,636 :: 		calc_disc_smpl();                          // Calculate disc sample pulse width and set timer values
	CALL        _calc_disc_smpl+0, 0
;Voodoo_V1.c,640 :: 		EEPROM_Write(20, txonh);
	MOVLW       20
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _txonh+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,641 :: 		EEPROM_Write(21, txonl);
	MOVLW       21
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _txonl+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,642 :: 		EEPROM_Write(22, main_dlyh);
	MOVLW       22
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _main_dlyh+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,643 :: 		EEPROM_Write(23, main_dlyl);
	MOVLW       23
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _main_dlyl+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,644 :: 		EEPROM_Write(24, main_smplh);
	MOVLW       24
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _main_smplh+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,645 :: 		EEPROM_Write(25, main_smpll);
	MOVLW       25
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _main_smpll+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,646 :: 		EEPROM_Write(26, efe_dlyh);
	MOVLW       26
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _efe_dlyh+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,647 :: 		EEPROM_Write(27, efe_dlyl);
	MOVLW       27
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _efe_dlyl+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,648 :: 		EEPROM_Write(28, txpdh);
	MOVLW       28
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _txpdh+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,649 :: 		EEPROM_Write(29, txpdl);
	MOVLW       29
	MOVWF       FARG_EEPROM_Write_address+0 
	MOVF        _txpdl+0, 0 
	MOVWF       FARG_EEPROM_Write_data_+0 
	CALL        _EEPROM_Write+0, 0
;Voodoo_V1.c,652 :: 		clear_arrays();                            // Clear both PI and DISC arrays
	CALL        _clear_arrays+0, 0
;Voodoo_V1.c,653 :: 		int_state = 0;                             // Reset interrupt state machine
	CLRF        _int_state+0 
;Voodoo_V1.c,654 :: 		PIE1 = 0x01;                               // Enable TMR0 interrupt
	MOVLW       1
	MOVWF       PIE1+0 
;Voodoo_V1.c,655 :: 		INTCON = 0xE0;                             // Enable global, peripheral and TMR1 interrupts
	MOVLW       224
	MOVWF       INTCON+0 
;Voodoo_V1.c,656 :: 		} else {
	GOTO        L_menu_system124
L_menu_system123:
;Voodoo_V1.c,657 :: 		if (keypad_btn == enter_btn) {             // Navigate menu system
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system307
	MOVLW       4
	XORWF       _keypad_btn+0, 0 
L__menu_system307:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system125
;Voodoo_V1.c,658 :: 		switch (menu_disp) {
	GOTO        L_menu_system126
;Voodoo_V1.c,659 :: 		case 0:                                  // Detect mode
L_menu_system128:
;Voodoo_V1.c,660 :: 		if (detect_mode == hybrid) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__menu_system308
	MOVLW       1
	XORWF       _detect_mode+0, 0 
L__menu_system308:
	BTFSS       STATUS+0, 2 
	GOTO        L_menu_system129
;Voodoo_V1.c,661 :: 		menu_disp = 6;                       // Go to hybrid settings
	MOVLW       6
	MOVWF       _menu_disp+0 
;Voodoo_V1.c,662 :: 		} else {
	GOTO        L_menu_system130
L_menu_system129:
;Voodoo_V1.c,663 :: 		menu_disp = 1;                       // Go to pulse settings
	MOVLW       1
	MOVWF       _menu_disp+0 
;Voodoo_V1.c,664 :: 		}
L_menu_system130:
;Voodoo_V1.c,665 :: 		break;
	GOTO        L_menu_system127
;Voodoo_V1.c,666 :: 		case 1:                                  // PI threshold
L_menu_system131:
;Voodoo_V1.c,667 :: 		menu_disp = 2;
	MOVLW       2
	MOVWF       _menu_disp+0 
;Voodoo_V1.c,668 :: 		break;
	GOTO        L_menu_system127
;Voodoo_V1.c,669 :: 		case 2:                                  // PI pulse width
L_menu_system132:
;Voodoo_V1.c,670 :: 		menu_disp = 3;
	MOVLW       3
	MOVWF       _menu_disp+0 
;Voodoo_V1.c,671 :: 		break;
	GOTO        L_menu_system127
;Voodoo_V1.c,672 :: 		case 3:                                  // PI sample delay
L_menu_system133:
;Voodoo_V1.c,673 :: 		menu_disp = 4;
	MOVLW       4
	MOVWF       _menu_disp+0 
;Voodoo_V1.c,674 :: 		break;
	GOTO        L_menu_system127
;Voodoo_V1.c,675 :: 		case 4:                                  // PI sample pulse width
L_menu_system134:
;Voodoo_V1.c,676 :: 		menu_disp = 5;
	MOVLW       5
	MOVWF       _menu_disp+0 
;Voodoo_V1.c,677 :: 		break;
	GOTO        L_menu_system127
;Voodoo_V1.c,678 :: 		case 5:                                  // PI running average
L_menu_system135:
;Voodoo_V1.c,679 :: 		menu_disp = 0;
	CLRF        _menu_disp+0 
;Voodoo_V1.c,680 :: 		break;
	GOTO        L_menu_system127
;Voodoo_V1.c,681 :: 		case 6:                                  // Disc threshold
L_menu_system136:
;Voodoo_V1.c,682 :: 		menu_disp = 7;
	MOVLW       7
	MOVWF       _menu_disp+0 
;Voodoo_V1.c,683 :: 		break;
	GOTO        L_menu_system127
;Voodoo_V1.c,684 :: 		case 7:                                  // Disc sample delay
L_menu_system137:
;Voodoo_V1.c,685 :: 		menu_disp = 8;
	MOVLW       8
	MOVWF       _menu_disp+0 
;Voodoo_V1.c,686 :: 		break;
	GOTO        L_menu_system127
;Voodoo_V1.c,687 :: 		case 8:                                  // Disc sample pulse width
L_menu_system138:
;Voodoo_V1.c,688 :: 		menu_disp = 9;
	MOVLW       9
	MOVWF       _menu_disp+0 
;Voodoo_V1.c,689 :: 		break;
	GOTO        L_menu_system127
;Voodoo_V1.c,690 :: 		case 9:
L_menu_system139:
;Voodoo_V1.c,691 :: 		menu_disp = 10;                        // Disc running average
	MOVLW       10
	MOVWF       _menu_disp+0 
;Voodoo_V1.c,692 :: 		break;
	GOTO        L_menu_system127
;Voodoo_V1.c,693 :: 		case 10:                                 // Meter zero limit
L_menu_system140:
;Voodoo_V1.c,694 :: 		menu_disp = 11;
	MOVLW       11
	MOVWF       _menu_disp+0 
;Voodoo_V1.c,695 :: 		break;
	GOTO        L_menu_system127
;Voodoo_V1.c,696 :: 		case 11:                                 // Accept and reject counter limit
L_menu_system141:
;Voodoo_V1.c,697 :: 		menu_disp = 0;
	CLRF        _menu_disp+0 
;Voodoo_V1.c,698 :: 		break;
	GOTO        L_menu_system127
;Voodoo_V1.c,699 :: 		}
L_menu_system126:
	MOVF        _menu_disp+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system128
	MOVF        _menu_disp+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system131
	MOVF        _menu_disp+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system132
	MOVF        _menu_disp+0, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system133
	MOVF        _menu_disp+0, 0 
	XORLW       4
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system134
	MOVF        _menu_disp+0, 0 
	XORLW       5
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system135
	MOVF        _menu_disp+0, 0 
	XORLW       6
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system136
	MOVF        _menu_disp+0, 0 
	XORLW       7
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system137
	MOVF        _menu_disp+0, 0 
	XORLW       8
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system138
	MOVF        _menu_disp+0, 0 
	XORLW       9
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system139
	MOVF        _menu_disp+0, 0 
	XORLW       10
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system140
	MOVF        _menu_disp+0, 0 
	XORLW       11
	BTFSC       STATUS+0, 2 
	GOTO        L_menu_system141
L_menu_system127:
;Voodoo_V1.c,700 :: 		}
L_menu_system125:
;Voodoo_V1.c,701 :: 		}
L_menu_system124:
;Voodoo_V1.c,702 :: 		}
	GOTO        L_menu_system56
L_menu_system57:
;Voodoo_V1.c,703 :: 		}
L_end_menu_system:
	RETURN      0
; end of _menu_system

_disp_reset:

;Voodoo_V1.c,705 :: 		void disp_reset() {
;Voodoo_V1.c,706 :: 		if (detect_mode == pulse) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__disp_reset310
	MOVLW       0
	XORWF       _detect_mode+0, 0 
L__disp_reset310:
	BTFSS       STATUS+0, 2 
	GOTO        L_disp_reset142
;Voodoo_V1.c,707 :: 		Lcd_Out(1, 1, " PULSE   ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr40_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr40_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,708 :: 		} else {
	GOTO        L_disp_reset143
L_disp_reset142:
;Voodoo_V1.c,709 :: 		Lcd_Out(1, 1, " HYBRID  ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr41_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr41_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,710 :: 		}
L_disp_reset143:
;Voodoo_V1.c,711 :: 		Lcd_Out(2, 1, "       ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr42_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr42_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,712 :: 		Lcd_Chr(2, 8, 7);                              // Display middle marker (vertical line)
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       8
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       7
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;Voodoo_V1.c,713 :: 		Lcd_Out(2, 9, "        ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       9
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr43_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr43_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,714 :: 		}
L_end_disp_reset:
	RETURN      0
; end of _disp_reset

_main:

;Voodoo_V1.c,717 :: 		void main() {
;Voodoo_V1.c,719 :: 		TRISA = TRISA_INIT;
	MOVLW       15
	MOVWF       TRISA+0 
;Voodoo_V1.c,720 :: 		TRISB = TRISB_INIT;
	MOVLW       192
	MOVWF       TRISB+0 
;Voodoo_V1.c,721 :: 		TRISC = TRISC_INIT;
	MOVLW       240
	MOVWF       TRISC+0 
;Voodoo_V1.c,722 :: 		TRISD = TRISD_INIT;
	MOVLW       56
	MOVWF       TRISD+0 
;Voodoo_V1.c,723 :: 		TRISE = TRISE_INIT;
	MOVLW       6
	MOVWF       TRISE+0 
;Voodoo_V1.c,726 :: 		EN1 = EN1_off;                                 // Turn off MOSFET
	BCF         LATD6_bit+0, BitPos(LATD6_bit+0) 
;Voodoo_V1.c,727 :: 		main_pulse = main_off;                         // Turn off main sample pulse
	BSF         LATC3_bit+0, BitPos(LATC3_bit+0) 
;Voodoo_V1.c,728 :: 		efe_pulse = efe_off;                           // Turn off EFE sample pulse
	BSF         LATD0_bit+0, BitPos(LATD0_bit+0) 
;Voodoo_V1.c,729 :: 		disc_pulse = disc_off;                         // Turn off disc sample pulse
	BSF         LATC1_bit+0, BitPos(LATC1_bit+0) 
;Voodoo_V1.c,732 :: 		ADCON1 = 0x07;                                 // Enable AD0 to AD7 (VDD and VSS as voltage reference)
	MOVLW       7
	MOVWF       ADCON1+0 
;Voodoo_V1.c,733 :: 		ADC_Init();
	CALL        _ADC_Init+0, 0
;Voodoo_V1.c,736 :: 		Lcd_Init();
	CALL        _Lcd_Init+0, 0
;Voodoo_V1.c,737 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Voodoo_V1.c,738 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);
	MOVLW       12
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Voodoo_V1.c,741 :: 		Lcd_Cmd(64);
	MOVLW       64
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Voodoo_V1.c,743 :: 		Lcd_Chr_Cp(14);
	MOVLW       14
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;Voodoo_V1.c,744 :: 		for (i = 2; i <= 8; i++) {Lcd_Chr_Cp(31);}
	MOVLW       2
	MOVWF       _i+0 
	MOVLW       0
	MOVWF       _i+1 
L_main144:
	MOVLW       0
	MOVWF       R0 
	MOVF        _i+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main312
	MOVF        _i+0, 0 
	SUBLW       8
L__main312:
	BTFSS       STATUS+0, 0 
	GOTO        L_main145
	MOVLW       31
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
	INFSNZ      _i+0, 1 
	INCF        _i+1, 1 
	GOTO        L_main144
L_main145:
;Voodoo_V1.c,746 :: 		Lcd_Chr_Cp(14);
	MOVLW       14
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;Voodoo_V1.c,747 :: 		Lcd_Chr_Cp(31);
	MOVLW       31
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;Voodoo_V1.c,748 :: 		Lcd_Chr_Cp(17);
	MOVLW       17
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;Voodoo_V1.c,749 :: 		for (i = 4; i <= 8; i++) {Lcd_Chr_Cp(31);}
	MOVLW       4
	MOVWF       _i+0 
	MOVLW       0
	MOVWF       _i+1 
L_main147:
	MOVLW       0
	MOVWF       R0 
	MOVF        _i+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main313
	MOVF        _i+0, 0 
	SUBLW       8
L__main313:
	BTFSS       STATUS+0, 0 
	GOTO        L_main148
	MOVLW       31
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
	INFSNZ      _i+0, 1 
	INCF        _i+1, 1 
	GOTO        L_main147
L_main148:
;Voodoo_V1.c,751 :: 		Lcd_Chr_Cp(14);
	MOVLW       14
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;Voodoo_V1.c,752 :: 		Lcd_Chr_Cp(31);
	MOVLW       31
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;Voodoo_V1.c,753 :: 		for (i = 3; i <= 4; i++) {Lcd_Chr_Cp(17);}
	MOVLW       3
	MOVWF       _i+0 
	MOVLW       0
	MOVWF       _i+1 
L_main150:
	MOVLW       0
	MOVWF       R0 
	MOVF        _i+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main314
	MOVF        _i+0, 0 
	SUBLW       4
L__main314:
	BTFSS       STATUS+0, 0 
	GOTO        L_main151
	MOVLW       17
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
	INFSNZ      _i+0, 1 
	INCF        _i+1, 1 
	GOTO        L_main150
L_main151:
;Voodoo_V1.c,754 :: 		for (i = 5; i <= 8; i++) {Lcd_Chr_Cp(31);}
	MOVLW       5
	MOVWF       _i+0 
	MOVLW       0
	MOVWF       _i+1 
L_main153:
	MOVLW       0
	MOVWF       R0 
	MOVF        _i+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main315
	MOVF        _i+0, 0 
	SUBLW       8
L__main315:
	BTFSS       STATUS+0, 0 
	GOTO        L_main154
	MOVLW       31
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
	INFSNZ      _i+0, 1 
	INCF        _i+1, 1 
	GOTO        L_main153
L_main154:
;Voodoo_V1.c,756 :: 		Lcd_Chr_Cp(14);
	MOVLW       14
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;Voodoo_V1.c,757 :: 		Lcd_Chr_Cp(31);
	MOVLW       31
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;Voodoo_V1.c,758 :: 		for (i = 3; i <= 5; i++) {Lcd_Chr_Cp(17);}
	MOVLW       3
	MOVWF       _i+0 
	MOVLW       0
	MOVWF       _i+1 
L_main156:
	MOVLW       0
	MOVWF       R0 
	MOVF        _i+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main316
	MOVF        _i+0, 0 
	SUBLW       5
L__main316:
	BTFSS       STATUS+0, 0 
	GOTO        L_main157
	MOVLW       17
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
	INFSNZ      _i+0, 1 
	INCF        _i+1, 1 
	GOTO        L_main156
L_main157:
;Voodoo_V1.c,759 :: 		for (i = 6; i <= 8; i++) {Lcd_Chr_Cp(31);}
	MOVLW       6
	MOVWF       _i+0 
	MOVLW       0
	MOVWF       _i+1 
L_main159:
	MOVLW       0
	MOVWF       R0 
	MOVF        _i+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main317
	MOVF        _i+0, 0 
	SUBLW       8
L__main317:
	BTFSS       STATUS+0, 0 
	GOTO        L_main160
	MOVLW       31
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
	INFSNZ      _i+0, 1 
	INCF        _i+1, 1 
	GOTO        L_main159
L_main160:
;Voodoo_V1.c,761 :: 		Lcd_Chr_Cp(14);
	MOVLW       14
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;Voodoo_V1.c,762 :: 		Lcd_Chr_Cp(31);
	MOVLW       31
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;Voodoo_V1.c,763 :: 		for (i = 3; i <= 6; i++) {Lcd_Chr_Cp(17);}
	MOVLW       3
	MOVWF       _i+0 
	MOVLW       0
	MOVWF       _i+1 
L_main162:
	MOVLW       0
	MOVWF       R0 
	MOVF        _i+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main318
	MOVF        _i+0, 0 
	SUBLW       6
L__main318:
	BTFSS       STATUS+0, 0 
	GOTO        L_main163
	MOVLW       17
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
	INFSNZ      _i+0, 1 
	INCF        _i+1, 1 
	GOTO        L_main162
L_main163:
;Voodoo_V1.c,764 :: 		for (i = 7; i <= 8; i++) {Lcd_Chr_Cp(31);}
	MOVLW       7
	MOVWF       _i+0 
	MOVLW       0
	MOVWF       _i+1 
L_main165:
	MOVLW       0
	MOVWF       R0 
	MOVF        _i+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main319
	MOVF        _i+0, 0 
	SUBLW       8
L__main319:
	BTFSS       STATUS+0, 0 
	GOTO        L_main166
	MOVLW       31
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
	INFSNZ      _i+0, 1 
	INCF        _i+1, 1 
	GOTO        L_main165
L_main166:
;Voodoo_V1.c,766 :: 		Lcd_Chr_Cp(14);
	MOVLW       14
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;Voodoo_V1.c,767 :: 		Lcd_Chr_Cp(31);
	MOVLW       31
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;Voodoo_V1.c,768 :: 		for (i = 3; i <= 7; i++) {Lcd_Chr_Cp(17);}
	MOVLW       3
	MOVWF       _i+0 
	MOVLW       0
	MOVWF       _i+1 
L_main168:
	MOVLW       0
	MOVWF       R0 
	MOVF        _i+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main320
	MOVF        _i+0, 0 
	SUBLW       7
L__main320:
	BTFSS       STATUS+0, 0 
	GOTO        L_main169
	MOVLW       17
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
	INFSNZ      _i+0, 1 
	INCF        _i+1, 1 
	GOTO        L_main168
L_main169:
;Voodoo_V1.c,769 :: 		Lcd_Chr_Cp(31);
	MOVLW       31
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
;Voodoo_V1.c,771 :: 		for (i = 1; i <= 8; i++) {Lcd_Chr_Cp(31);}
	MOVLW       1
	MOVWF       _i+0 
	MOVLW       0
	MOVWF       _i+1 
L_main171:
	MOVLW       0
	MOVWF       R0 
	MOVF        _i+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main321
	MOVF        _i+0, 0 
	SUBLW       8
L__main321:
	BTFSS       STATUS+0, 0 
	GOTO        L_main172
	MOVLW       31
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
	INFSNZ      _i+0, 1 
	INCF        _i+1, 1 
	GOTO        L_main171
L_main172:
;Voodoo_V1.c,773 :: 		for (i = 1; i <= 8; i++) {Lcd_Chr_Cp(4);}
	MOVLW       1
	MOVWF       _i+0 
	MOVLW       0
	MOVWF       _i+1 
L_main174:
	MOVLW       0
	MOVWF       R0 
	MOVF        _i+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main322
	MOVF        _i+0, 0 
	SUBLW       8
L__main322:
	BTFSS       STATUS+0, 0 
	GOTO        L_main175
	MOVLW       4
	MOVWF       FARG_Lcd_Chr_CP_out_char+0 
	CALL        _Lcd_Chr_CP+0, 0
	INFSNZ      _i+0, 1 
	INCF        _i+1, 1 
	GOTO        L_main174
L_main175:
;Voodoo_V1.c,776 :: 		Lcd_Out(1,1,"  VOODOO V1.1   ");
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr44_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr44_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,777 :: 		Lcd_Out(2,1,"HYBRID DETECTOR ");
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr45_Voodoo_V1+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr45_Voodoo_V1+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;Voodoo_V1.c,778 :: 		delay_ms(2000);
	MOVLW       51
	MOVWF       R11, 0
	MOVLW       187
	MOVWF       R12, 0
	MOVLW       223
	MOVWF       R13, 0
L_main177:
	DECFSZ      R13, 1, 1
	BRA         L_main177
	DECFSZ      R12, 1, 1
	BRA         L_main177
	DECFSZ      R11, 1, 1
	BRA         L_main177
	NOP
	NOP
;Voodoo_V1.c,779 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;Voodoo_V1.c,782 :: 		int_state = 0;                                 // Initialize interrupt state machine
	CLRF        _int_state+0 
;Voodoo_V1.c,783 :: 		main_state = 0;                                // Initialize main state machine
	CLRF        _main_state+0 
;Voodoo_V1.c,784 :: 		loop_count = 0;                                // Reset loop counter
	CLRF        _loop_count+0 
;Voodoo_V1.c,785 :: 		hybrid_cycle = 0;                              // Hybrid operating cycle (0 = pulse, 1 = disc)
	CLRF        _hybrid_cycle+0 
;Voodoo_V1.c,786 :: 		accept = 0;                                    // Clear accept (non-ferrous) counter
	CLRF        _accept+0 
;Voodoo_V1.c,787 :: 		accept_blk = 0;                                // Clear accept block display counter
	CLRF        _accept_blk+0 
;Voodoo_V1.c,788 :: 		reject = 0;                                    // Clear reject (ferrous) counter
	CLRF        _reject+0 
;Voodoo_V1.c,789 :: 		reject_blk = 0;                                // Clear reject block display counter
	CLRF        _reject_blk+0 
;Voodoo_V1.c,790 :: 		update_disp = 0;                               // Clear update display flag
	CLRF        _update_disp+0 
;Voodoo_V1.c,791 :: 		meter_zero = 0;                                // Clear meter zero counter
	CLRF        _meter_zero+0 
;Voodoo_V1.c,794 :: 		detect_mode = hybrid;                          // Set default detection mode to hybrid
	MOVLW       1
	MOVWF       _detect_mode+0 
;Voodoo_V1.c,795 :: 		pi_thr = 525;                                  // Set default pi threshold
	MOVLW       13
	MOVWF       _pi_thr+0 
	MOVLW       2
	MOVWF       _pi_thr+1 
;Voodoo_V1.c,796 :: 		disc_thr = 511;                                // Set default disc threshold
	MOVLW       255
	MOVWF       _disc_thr+0 
	MOVLW       1
	MOVWF       _disc_thr+1 
;Voodoo_V1.c,797 :: 		txon = 150;                                    // Set default TX pulse width (us)
	MOVLW       150
	MOVWF       _txon+0 
;Voodoo_V1.c,798 :: 		txpd = 1000;                                   // Set default TX pulse period (us)
	MOVLW       232
	MOVWF       _txpd+0 
	MOVLW       3
	MOVWF       _txpd+1 
;Voodoo_V1.c,799 :: 		main_dly = 27;                                 // Set default main sample delay (us)
	MOVLW       27
	MOVWF       _main_dly+0 
;Voodoo_V1.c,800 :: 		main_smpl = 60;                                // Set default main sample pulse width (us)
	MOVLW       60
	MOVWF       _main_smpl+0 
;Voodoo_V1.c,801 :: 		efe_dly = 400;                                 // Set default EFE sample delay (us)
	MOVLW       144
	MOVWF       _efe_dly+0 
	MOVLW       1
	MOVWF       _efe_dly+1 
;Voodoo_V1.c,802 :: 		pi_num = 64;                                   // Set default number of PI readings to average
	MOVLW       64
	MOVWF       _pi_num+0 
;Voodoo_V1.c,803 :: 		disc_dly = 45;                                 // Set default disc sample delay (us)
	MOVLW       45
	MOVWF       _disc_dly+0 
;Voodoo_V1.c,804 :: 		disc_smpl = 45;                                // Set default disc sample pulse width (us)
	MOVLW       45
	MOVWF       _disc_smpl+0 
;Voodoo_V1.c,805 :: 		disc_num = 64;                                 // Set default number of disc readings to average
	MOVLW       64
	MOVWF       _disc_num+0 
;Voodoo_V1.c,806 :: 		meter_zero_limit = 10;                         // Set meter zero limit
	MOVLW       10
	MOVWF       _meter_zero_limit+0 
;Voodoo_V1.c,807 :: 		counter_limit = 100;                           // Set accept and reject counter limit
	MOVLW       100
	MOVWF       _counter_limit+0 
;Voodoo_V1.c,809 :: 		clear_arrays();                                // Clear both PI and DISC arrays
	CALL        _clear_arrays+0, 0
;Voodoo_V1.c,812 :: 		if (EEPROM_Read(0) == 0xAA) {                  // Check if EEPROM already initialized
	CLRF        FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	XORLW       170
	BTFSS       STATUS+0, 2 
	GOTO        L_main178
;Voodoo_V1.c,813 :: 		detect_mode = EEPROM_Read(1);                // Read detection mode (pulse or hybrid)
	MOVLW       1
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _detect_mode+0 
;Voodoo_V1.c,814 :: 		pi_thr = EEPROM_Read(2);                     // Read PI threshold high byte
	MOVLW       2
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _pi_thr+0 
	MOVLW       0
	MOVWF       _pi_thr+1 
;Voodoo_V1.c,815 :: 		pi_thr = pi_thr << 8;
	MOVF        _pi_thr+0, 0 
	MOVWF       _pi_thr+1 
	CLRF        _pi_thr+0 
;Voodoo_V1.c,816 :: 		pi_thr += EEPROM_Read(3);                    // Read PI threshold low byte
	MOVLW       3
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	ADDWF       _pi_thr+0, 1 
	MOVLW       0
	ADDWFC      _pi_thr+1, 1 
;Voodoo_V1.c,817 :: 		txon = EEPROM_Read(4);                       // Read TX pulse width
	MOVLW       4
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _txon+0 
;Voodoo_V1.c,818 :: 		txpd = EEPROM_Read(5);                       // Read TX period high byte
	MOVLW       5
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _txpd+0 
	MOVLW       0
	MOVWF       _txpd+1 
;Voodoo_V1.c,819 :: 		txpd = txpd << 8;
	MOVF        _txpd+0, 0 
	MOVWF       _txpd+1 
	CLRF        _txpd+0 
;Voodoo_V1.c,820 :: 		txpd += EEPROM_Read(6);                      // Read TX period low byte
	MOVLW       6
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	ADDWF       _txpd+0, 1 
	MOVLW       0
	ADDWFC      _txpd+1, 1 
;Voodoo_V1.c,821 :: 		main_dly = EEPROM_Read(7);                   // Read main sample delay
	MOVLW       7
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _main_dly+0 
;Voodoo_V1.c,822 :: 		main_smpl = EEPROM_Read(8);                  // Read main sample pulse width
	MOVLW       8
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _main_smpl+0 
;Voodoo_V1.c,823 :: 		efe_dly = EEPROM_Read(9);                    // Read EFE sample delay high byte
	MOVLW       9
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _efe_dly+0 
	MOVLW       0
	MOVWF       _efe_dly+1 
;Voodoo_V1.c,824 :: 		efe_dly = efe_dly << 8;
	MOVF        _efe_dly+0, 0 
	MOVWF       _efe_dly+1 
	CLRF        _efe_dly+0 
;Voodoo_V1.c,825 :: 		efe_dly += EEPROM_Read(10);                  // Read EFE sample delay low byte
	MOVLW       10
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	ADDWF       _efe_dly+0, 1 
	MOVLW       0
	ADDWFC      _efe_dly+1, 1 
;Voodoo_V1.c,826 :: 		pi_num = EEPROM_Read(11);                    // Read number of PI readings to average
	MOVLW       11
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _pi_num+0 
;Voodoo_V1.c,827 :: 		disc_thr = EEPROM_Read(12);                  // Read disc threshold high byte
	MOVLW       12
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _disc_thr+0 
	MOVLW       0
	MOVWF       _disc_thr+1 
;Voodoo_V1.c,828 :: 		disc_thr = disc_thr << 8;
	MOVF        _disc_thr+0, 0 
	MOVWF       _disc_thr+1 
	CLRF        _disc_thr+0 
;Voodoo_V1.c,829 :: 		disc_thr += EEPROM_Read(13);                 // Read disc threshold low byte
	MOVLW       13
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	ADDWF       _disc_thr+0, 1 
	MOVLW       0
	ADDWFC      _disc_thr+1, 1 
;Voodoo_V1.c,830 :: 		disc_dly = EEPROM_Read(14);                  // Read disc sample delay
	MOVLW       14
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _disc_dly+0 
;Voodoo_V1.c,831 :: 		disc_smpl = EEPROM_Read(15);                 // Read disc sample pulse width
	MOVLW       15
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _disc_smpl+0 
;Voodoo_V1.c,832 :: 		disc_num = EEPROM_Read(16);                  // Read number of disc readings to average
	MOVLW       16
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _disc_num+0 
;Voodoo_V1.c,833 :: 		meter_zero_limit = EEPROM_Read(17);          // Read meter zero limit
	MOVLW       17
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _meter_zero_limit+0 
;Voodoo_V1.c,834 :: 		counter_limit = EEPROM_Read(18);             // Read accept and reject counter limit
	MOVLW       18
	MOVWF       FARG_EEPROM_Read_address+0 
	CALL        _EEPROM_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _counter_limit+0 
;Voodoo_V1.c,835 :: 		} else{
	GOTO        L_main179
L_main178:
;Voodoo_V1.c,836 :: 		write_eeprom();                              // Write settings to EEPROM
	CALL        _write_eeprom+0, 0
;Voodoo_V1.c,837 :: 		}
L_main179:
;Voodoo_V1.c,838 :: 		calc_txon();                                   // Calculate TX pulse width and set timer values
	CALL        _calc_txon+0, 0
;Voodoo_V1.c,839 :: 		calc_txpd();                                   // Calculate TX period and set timer values
	CALL        _calc_txpd+0, 0
;Voodoo_V1.c,840 :: 		calc_main_dly();                               // Calculate main sample delay and set timer values
	CALL        _calc_main_dly+0, 0
;Voodoo_V1.c,841 :: 		calc_main_smpl();                              // Calculate main sample pulse width and set timer values
	CALL        _calc_main_smpl+0, 0
;Voodoo_V1.c,842 :: 		calc_efe_dly();                                // Calculate EFE sample delay and set timer values
	CALL        _calc_efe_dly+0, 0
;Voodoo_V1.c,843 :: 		calc_efe_smpl();                               // Calculate EFE sample pulse width and set timer values
	CALL        _calc_efe_smpl+0, 0
;Voodoo_V1.c,844 :: 		calc_disc_dly();                               // Calculate disc sample delay and set timer values
	CALL        _calc_disc_dly+0, 0
;Voodoo_V1.c,845 :: 		calc_disc_smpl();                              // Calculate disc sample pulse width and set timer values
	CALL        _calc_disc_smpl+0, 0
;Voodoo_V1.c,846 :: 		disp_reset();                                  // Reset display
	CALL        _disp_reset+0, 0
;Voodoo_V1.c,851 :: 		T0CON = 0x88;                                  // Configure TMR0 as 16-bit
	MOVLW       136
	MOVWF       T0CON+0 
;Voodoo_V1.c,852 :: 		T1CON = 0x85;                                  // Configure TMR1 as 16-bit
	MOVLW       133
	MOVWF       T1CON+0 
;Voodoo_V1.c,853 :: 		TMR0H = txonh;                                 // Load TX pulse width
	MOVF        _txonh+0, 0 
	MOVWF       TMR0H+0 
;Voodoo_V1.c,854 :: 		TMR0L = txonl;
	MOVF        _txonl+0, 0 
	MOVWF       TMR0L+0 
;Voodoo_V1.c,855 :: 		TMR1H = txpdh;                                 // Load TX period
	MOVF        _txpdh+0, 0 
	MOVWF       TMR1H+0 
;Voodoo_V1.c,856 :: 		TMR1H = txpdl;
	MOVF        _txpdl+0, 0 
	MOVWF       TMR1H+0 
;Voodoo_V1.c,857 :: 		PIR1 = 0x00;                                   // Clear TMR1 interrupt overflow flag
	CLRF        PIR1+0 
;Voodoo_V1.c,858 :: 		PIE1 = 0x01;                                   // Enable TMR1 overflow interrupt
	MOVLW       1
	MOVWF       PIE1+0 
;Voodoo_V1.c,859 :: 		INTCON = 0xE0;                                 // Enable interrupts
	MOVLW       224
	MOVWF       INTCON+0 
;Voodoo_V1.c,861 :: 		while(1) {
L_main180:
;Voodoo_V1.c,862 :: 		switch (main_state) {
	GOTO        L_main182
;Voodoo_V1.c,863 :: 		case 0:
L_main184:
;Voodoo_V1.c,864 :: 		pi_target = Adc_Read(pi_adc);            // Acquire PI target reading
	MOVF        _pi_adc+0, 0 
	MOVWF       FARG_ADC_Read_channel+0 
	CALL        _ADC_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _pi_target+0 
	MOVF        R1, 0 
	MOVWF       _pi_target+1 
;Voodoo_V1.c,865 :: 		pi_tmp = pi_array[pi_pointer];           // Save current PI array value
	MOVF        _pi_pointer+0, 0 
	MOVWF       R2 
	MOVLW       0
	MOVWF       R3 
	RLCF        R2, 1 
	BCF         R2, 0 
	RLCF        R3, 1 
	MOVLW       _pi_array+0
	ADDWF       R2, 1 
	MOVLW       hi_addr(_pi_array+0)
	ADDWFC      R3, 1 
	MOVFF       R2, FSR0L+0
	MOVFF       R3, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       _pi_tmp+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       _pi_tmp+1 
;Voodoo_V1.c,866 :: 		pi_array[pi_pointer] = pi_target;        // Add latest reading to PI array
	MOVFF       R2, FSR1L+0
	MOVFF       R3, FSR1H+0
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;Voodoo_V1.c,867 :: 		pi_total = (pi_total + pi_target) - pi_tmp; // Calculate PI array total
	MOVF        _pi_target+0, 0 
	ADDWF       _pi_total+0, 0 
	MOVWF       R0 
	MOVF        _pi_target+1, 0 
	ADDWFC      _pi_total+1, 0 
	MOVWF       R1 
	MOVF        _pi_tmp+0, 0 
	SUBWF       R0, 1 
	MOVF        _pi_tmp+1, 0 
	SUBWFB      R1, 1 
	MOVF        R0, 0 
	MOVWF       _pi_total+0 
	MOVF        R1, 0 
	MOVWF       _pi_total+1 
;Voodoo_V1.c,868 :: 		pi_target = pi_total / pi_num;           // Average readings
	MOVF        _pi_num+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Div_16X16_U+0, 0
	MOVF        R0, 0 
	MOVWF       _pi_target+0 
	MOVF        R1, 0 
	MOVWF       _pi_target+1 
;Voodoo_V1.c,869 :: 		pi_pointer++;                            // Increment PI pointer
	INCF        _pi_pointer+0, 1 
;Voodoo_V1.c,870 :: 		if (pi_pointer >= pi_num) {
	MOVF        _pi_num+0, 0 
	SUBWF       _pi_pointer+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L_main185
;Voodoo_V1.c,871 :: 		pi_pointer = 0;                        // Reset PI array pointer
	CLRF        _pi_pointer+0 
;Voodoo_V1.c,872 :: 		}
L_main185:
;Voodoo_V1.c,873 :: 		if (detect_mode == hybrid) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main323
	MOVLW       1
	XORWF       _detect_mode+0, 0 
L__main323:
	BTFSS       STATUS+0, 2 
	GOTO        L_main186
;Voodoo_V1.c,874 :: 		disc_target = Adc_Read(disc_adc);      // Acquire DISC target reading
	MOVF        _disc_adc+0, 0 
	MOVWF       FARG_ADC_Read_channel+0 
	CALL        _ADC_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _disc_target+0 
	MOVF        R1, 0 
	MOVWF       _disc_target+1 
;Voodoo_V1.c,875 :: 		disc_tmp = disc_array[disc_pointer];   // Save current disc array value
	MOVF        _disc_pointer+0, 0 
	MOVWF       R2 
	MOVLW       0
	MOVWF       R3 
	RLCF        R2, 1 
	BCF         R2, 0 
	RLCF        R3, 1 
	MOVLW       _disc_array+0
	ADDWF       R2, 1 
	MOVLW       hi_addr(_disc_array+0)
	ADDWFC      R3, 1 
	MOVFF       R2, FSR0L+0
	MOVFF       R3, FSR0H+0
	MOVF        POSTINC0+0, 0 
	MOVWF       _disc_tmp+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       _disc_tmp+1 
;Voodoo_V1.c,876 :: 		disc_array[disc_pointer] = disc_target; // Add latest reading to disc array
	MOVFF       R2, FSR1L+0
	MOVFF       R3, FSR1H+0
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;Voodoo_V1.c,877 :: 		disc_total = (disc_total + disc_target) - disc_tmp; // Calculate disc array total;
	MOVF        _disc_target+0, 0 
	ADDWF       _disc_total+0, 0 
	MOVWF       R0 
	MOVF        _disc_target+1, 0 
	ADDWFC      _disc_total+1, 0 
	MOVWF       R1 
	MOVF        _disc_tmp+0, 0 
	SUBWF       R0, 1 
	MOVF        _disc_tmp+1, 0 
	SUBWFB      R1, 1 
	MOVF        R0, 0 
	MOVWF       _disc_total+0 
	MOVF        R1, 0 
	MOVWF       _disc_total+1 
;Voodoo_V1.c,878 :: 		disc_target = disc_total / disc_num;   // Average readings
	MOVF        _disc_num+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Div_16X16_U+0, 0
	MOVF        R0, 0 
	MOVWF       _disc_target+0 
	MOVF        R1, 0 
	MOVWF       _disc_target+1 
;Voodoo_V1.c,879 :: 		disc_pointer++;                        // Increment disc pointer
	INCF        _disc_pointer+0, 1 
;Voodoo_V1.c,880 :: 		if (disc_pointer >= disc_num) {
	MOVF        _disc_num+0, 0 
	SUBWF       _disc_pointer+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L_main187
;Voodoo_V1.c,881 :: 		disc_pointer = 0;                    // Reset disc array pointer
	CLRF        _disc_pointer+0 
;Voodoo_V1.c,882 :: 		}
L_main187:
;Voodoo_V1.c,883 :: 		}
L_main186:
;Voodoo_V1.c,885 :: 		if (pi_target >= pi_thr) {               // Decide whether to beep or not
	MOVF        _pi_thr+1, 0 
	SUBWF       _pi_target+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main324
	MOVF        _pi_thr+0, 0 
	SUBWF       _pi_target+0, 0 
L__main324:
	BTFSS       STATUS+0, 0 
	GOTO        L_main188
;Voodoo_V1.c,886 :: 		if (detect_mode == hybrid) {           // Check for hybrid mode
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main325
	MOVLW       1
	XORWF       _detect_mode+0, 0 
L__main325:
	BTFSS       STATUS+0, 2 
	GOTO        L_main189
;Voodoo_V1.c,887 :: 		update_disp = 0;                     // Reset update display flag
	CLRF        _update_disp+0 
;Voodoo_V1.c,888 :: 		if (disc_target >= disc_thr) {       // Non-ferrous target detected
	MOVF        _disc_thr+1, 0 
	SUBWF       _disc_target+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main326
	MOVF        _disc_thr+0, 0 
	SUBWF       _disc_target+0, 0 
L__main326:
	BTFSS       STATUS+0, 0 
	GOTO        L_main190
;Voodoo_V1.c,889 :: 		audio_en = audio_on;               // Beep
	BSF         LATA4_bit+0, BitPos(LATA4_bit+0) 
;Voodoo_V1.c,890 :: 		if (reject_blk == 0) {
	MOVF        _reject_blk+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_main191
;Voodoo_V1.c,891 :: 		accept++;                        // Increment accept counter if no reject blocks displayed
	INCF        _accept+0, 1 
;Voodoo_V1.c,892 :: 		reject = 0;                      // Clear reject counter
	CLRF        _reject+0 
;Voodoo_V1.c,893 :: 		if (accept > counter_limit) {    // Check if accept counter has reached limit
	MOVF        _accept+0, 0 
	SUBWF       _counter_limit+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_main192
;Voodoo_V1.c,894 :: 		accept = 0;                    // Reset accept counter to zero
	CLRF        _accept+0 
;Voodoo_V1.c,895 :: 		accept_blk++;                  // Increment number of accept blocks
	INCF        _accept_blk+0, 1 
;Voodoo_V1.c,896 :: 		if (accept_blk <= blk_limit) {
	MOVLW       128
	XORLW       0
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main327
	MOVF        _accept_blk+0, 0 
	SUBLW       7
L__main327:
	BTFSS       STATUS+0, 0 
	GOTO        L_main193
;Voodoo_V1.c,897 :: 		update_disp = 1;             // Set update display flag
	MOVLW       1
	MOVWF       _update_disp+0 
;Voodoo_V1.c,898 :: 		} else {
	GOTO        L_main194
L_main193:
;Voodoo_V1.c,899 :: 		accept_blk = blk_limit;      // Limit number of accept blocks
	MOVLW       7
	MOVWF       _accept_blk+0 
;Voodoo_V1.c,900 :: 		}
L_main194:
;Voodoo_V1.c,901 :: 		}
L_main192:
;Voodoo_V1.c,902 :: 		} else {                           // There must be some reject blocks displayed
	GOTO        L_main195
L_main191:
;Voodoo_V1.c,903 :: 		if (reject != 0) {
	MOVF        _reject+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_main196
;Voodoo_V1.c,904 :: 		reject--;                      // Decrement reject counter if not at zero
	DECF        _reject+0, 1 
;Voodoo_V1.c,905 :: 		} else {                         // Reject counter must have reached zero
	GOTO        L_main197
L_main196:
;Voodoo_V1.c,906 :: 		reject = counter_limit;        // Set reject counter to limit
	MOVF        _counter_limit+0, 0 
	MOVWF       _reject+0 
;Voodoo_V1.c,907 :: 		if (reject_blk != 0) {
	MOVF        _reject_blk+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_main198
;Voodoo_V1.c,908 :: 		reject_blk--;                // Decrement number of reject blocks if not zero
	DECF        _reject_blk+0, 1 
;Voodoo_V1.c,909 :: 		update_disp = 1;             // Set update display flag
	MOVLW       1
	MOVWF       _update_disp+0 
;Voodoo_V1.c,910 :: 		}
L_main198:
;Voodoo_V1.c,911 :: 		}
L_main197:
;Voodoo_V1.c,912 :: 		}
L_main195:
;Voodoo_V1.c,913 :: 		} else {                             // Ferrous target detected
	GOTO        L_main199
L_main190:
;Voodoo_V1.c,914 :: 		audio_en = audio_off;              // Do not beep
	BCF         LATA4_bit+0, BitPos(LATA4_bit+0) 
;Voodoo_V1.c,915 :: 		if (accept_blk == 0) {
	MOVF        _accept_blk+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_main200
;Voodoo_V1.c,916 :: 		reject++;                        // Increment reject counter if no accept blocks displayed
	INCF        _reject+0, 1 
;Voodoo_V1.c,917 :: 		accept = 0;                      // Clear accept counter
	CLRF        _accept+0 
;Voodoo_V1.c,918 :: 		if (reject > counter_limit) {    // Check if reject counter has reached limit
	MOVF        _reject+0, 0 
	SUBWF       _counter_limit+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_main201
;Voodoo_V1.c,919 :: 		reject = 0;                    // Reset reject counter to zero
	CLRF        _reject+0 
;Voodoo_V1.c,920 :: 		reject_blk++;                  // Increment number of reject blocks
	INCF        _reject_blk+0, 1 
;Voodoo_V1.c,921 :: 		if (reject_blk <= blk_limit) {
	MOVLW       128
	XORLW       0
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main328
	MOVF        _reject_blk+0, 0 
	SUBLW       7
L__main328:
	BTFSS       STATUS+0, 0 
	GOTO        L_main202
;Voodoo_V1.c,922 :: 		update_disp = 1;             // Set update display flag
	MOVLW       1
	MOVWF       _update_disp+0 
;Voodoo_V1.c,923 :: 		} else {
	GOTO        L_main203
L_main202:
;Voodoo_V1.c,924 :: 		reject_blk = blk_limit;      // Limit number of reject blocks
	MOVLW       7
	MOVWF       _reject_blk+0 
;Voodoo_V1.c,925 :: 		}
L_main203:
;Voodoo_V1.c,926 :: 		}
L_main201:
;Voodoo_V1.c,927 :: 		} else {                           // There must be some accept blocks displayed
	GOTO        L_main204
L_main200:
;Voodoo_V1.c,928 :: 		if (accept != 0) {
	MOVF        _accept+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_main205
;Voodoo_V1.c,929 :: 		accept--;                      // Decrement accept counter is not at zero
	DECF        _accept+0, 1 
;Voodoo_V1.c,930 :: 		} else {                         // Accept counter must have reached zero
	GOTO        L_main206
L_main205:
;Voodoo_V1.c,931 :: 		accept = counter_limit;        // Set accept counter to limit
	MOVF        _counter_limit+0, 0 
	MOVWF       _accept+0 
;Voodoo_V1.c,932 :: 		if (accept_blk != 0) {
	MOVF        _accept_blk+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_main207
;Voodoo_V1.c,933 :: 		accept_blk--;                // Decrement number of accept blocks if not zero
	DECF        _accept_blk+0, 1 
;Voodoo_V1.c,934 :: 		update_disp = 1;             // Set update display flag
	MOVLW       1
	MOVWF       _update_disp+0 
;Voodoo_V1.c,935 :: 		}
L_main207:
;Voodoo_V1.c,936 :: 		}
L_main206:
;Voodoo_V1.c,937 :: 		}
L_main204:
;Voodoo_V1.c,938 :: 		}
L_main199:
;Voodoo_V1.c,940 :: 		} else {                               // Mode must be PI
	GOTO        L_main208
L_main189:
;Voodoo_V1.c,941 :: 		audio_en = audio_on;                 // Beep
	BSF         LATA4_bit+0, BitPos(LATA4_bit+0) 
;Voodoo_V1.c,942 :: 		}
L_main208:
;Voodoo_V1.c,943 :: 		} else {                                 // No target detected
	GOTO        L_main209
L_main188:
;Voodoo_V1.c,944 :: 		audio_en = audio_off;                  // Do not beep
	BCF         LATA4_bit+0, BitPos(LATA4_bit+0) 
;Voodoo_V1.c,945 :: 		}
L_main209:
;Voodoo_V1.c,946 :: 		if (update_disp == 0) {                  // Only zero display when no signal is present
	MOVF        _update_disp+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_main210
;Voodoo_V1.c,947 :: 		meter_zero++;                          // Increment meter zero counter
	INCF        _meter_zero+0, 1 
;Voodoo_V1.c,948 :: 		if (meter_zero >= meter_zero_limit) {
	MOVF        _meter_zero_limit+0, 0 
	SUBWF       _meter_zero+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L_main211
;Voodoo_V1.c,949 :: 		if (accept_blk != 0) {               // Must be accept blocks displayed
	MOVF        _accept_blk+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_main212
;Voodoo_V1.c,950 :: 		if (accept != 0) {
	MOVF        _accept+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_main213
;Voodoo_V1.c,951 :: 		accept--;                        // Decrement accept counter if not already zero
	DECF        _accept+0, 1 
;Voodoo_V1.c,952 :: 		} else {
	GOTO        L_main214
L_main213:
;Voodoo_V1.c,953 :: 		accept_blk--;                    // Decrement number of accept blocks
	DECF        _accept_blk+0, 1 
;Voodoo_V1.c,954 :: 		accept = counter_limit;          // Set accept counter to limit
	MOVF        _counter_limit+0, 0 
	MOVWF       _accept+0 
;Voodoo_V1.c,955 :: 		update_disp = 1;                 // Set update display flag
	MOVLW       1
	MOVWF       _update_disp+0 
;Voodoo_V1.c,956 :: 		}
L_main214:
;Voodoo_V1.c,957 :: 		} else {
	GOTO        L_main215
L_main212:
;Voodoo_V1.c,958 :: 		if (reject_blk != 0) {             // Otherwise must be reject blocks displayed
	MOVF        _reject_blk+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_main216
;Voodoo_V1.c,959 :: 		if (reject != 0) {
	MOVF        _reject+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_main217
;Voodoo_V1.c,960 :: 		reject--;                      // Decrement reject counter if not already zero
	DECF        _reject+0, 1 
;Voodoo_V1.c,961 :: 		} else {
	GOTO        L_main218
L_main217:
;Voodoo_V1.c,962 :: 		reject_blk--;                  // Decrement number of reject blocks displayed
	DECF        _reject_blk+0, 1 
;Voodoo_V1.c,963 :: 		reject = counter_limit;        // Set reject counter to limit
	MOVF        _counter_limit+0, 0 
	MOVWF       _reject+0 
;Voodoo_V1.c,964 :: 		update_disp = 1;               // Set update display flag
	MOVLW       1
	MOVWF       _update_disp+0 
;Voodoo_V1.c,965 :: 		}
L_main218:
;Voodoo_V1.c,966 :: 		}
L_main216:
;Voodoo_V1.c,967 :: 		}
L_main215:
;Voodoo_V1.c,968 :: 		meter_zero = 0;                      // Reset meter zero counter
	CLRF        _meter_zero+0 
;Voodoo_V1.c,969 :: 		}
L_main211:
;Voodoo_V1.c,970 :: 		}
L_main210:
;Voodoo_V1.c,971 :: 		if (update_disp == 1) {                  // Check if display needs to be updated
	MOVF        _update_disp+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_main219
;Voodoo_V1.c,972 :: 		if (accept_blk != 0) {
	MOVF        _accept_blk+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_main220
;Voodoo_V1.c,973 :: 		for (i = 1; i <= accept_blk; i++) {
	MOVLW       1
	MOVWF       _i+0 
	MOVLW       0
	MOVWF       _i+1 
L_main221:
	MOVLW       0
	MOVWF       R0 
	MOVF        _i+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main329
	MOVF        _i+0, 0 
	SUBWF       _accept_blk+0, 0 
L__main329:
	BTFSS       STATUS+0, 0 
	GOTO        L_main222
;Voodoo_V1.c,974 :: 		Lcd_Chr(2, 8 + i, 6);              // Display required number of non-ferrous blocks
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVF        _i+0, 0 
	ADDLW       8
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       6
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;Voodoo_V1.c,973 :: 		for (i = 1; i <= accept_blk; i++) {
	INFSNZ      _i+0, 1 
	INCF        _i+1, 1 
;Voodoo_V1.c,975 :: 		}
	GOTO        L_main221
L_main222:
;Voodoo_V1.c,976 :: 		if (accept_blk != blk_limit) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main330
	MOVLW       7
	XORWF       _accept_blk+0, 0 
L__main330:
	BTFSC       STATUS+0, 2 
	GOTO        L_main224
;Voodoo_V1.c,977 :: 		for (i = accept_blk + 1; i <= blk_limit; i++) {
	MOVF        _accept_blk+0, 0 
	ADDLW       1
	MOVWF       _i+0 
	CLRF        _i+1 
	MOVLW       0
	ADDWFC      _i+1, 1 
L_main225:
	MOVF        _i+1, 0 
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main331
	MOVF        _i+0, 0 
	SUBLW       7
L__main331:
	BTFSS       STATUS+0, 0 
	GOTO        L_main226
;Voodoo_V1.c,978 :: 		Lcd_Chr(2, 8 + i, 32);           // Fill rest of non-ferrous display with spaces
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVF        _i+0, 0 
	ADDLW       8
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       32
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;Voodoo_V1.c,977 :: 		for (i = accept_blk + 1; i <= blk_limit; i++) {
	INFSNZ      _i+0, 1 
	INCF        _i+1, 1 
;Voodoo_V1.c,979 :: 		}
	GOTO        L_main225
L_main226:
;Voodoo_V1.c,980 :: 		}
L_main224:
;Voodoo_V1.c,981 :: 		} else {
	GOTO        L_main228
L_main220:
;Voodoo_V1.c,982 :: 		Lcd_Chr(2, 9, 32);                   // Clear first block in non-ferrous display
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       9
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       32
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;Voodoo_V1.c,983 :: 		if (reject_blk != 0) {
	MOVF        _reject_blk+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_main229
;Voodoo_V1.c,984 :: 		for (i = 1; i <= reject_blk; i++) {
	MOVLW       1
	MOVWF       _i+0 
	MOVLW       0
	MOVWF       _i+1 
L_main230:
	MOVLW       0
	MOVWF       R0 
	MOVF        _i+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main332
	MOVF        _i+0, 0 
	SUBWF       _reject_blk+0, 0 
L__main332:
	BTFSS       STATUS+0, 0 
	GOTO        L_main231
;Voodoo_V1.c,985 :: 		Lcd_Chr(2, 8 - i, 6);            // Display required number of ferrous blocks
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVF        _i+0, 0 
	SUBLW       8
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       6
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;Voodoo_V1.c,984 :: 		for (i = 1; i <= reject_blk; i++) {
	INFSNZ      _i+0, 1 
	INCF        _i+1, 1 
;Voodoo_V1.c,986 :: 		}
	GOTO        L_main230
L_main231:
;Voodoo_V1.c,987 :: 		if (reject_blk != blk_limit) {
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main333
	MOVLW       7
	XORWF       _reject_blk+0, 0 
L__main333:
	BTFSC       STATUS+0, 2 
	GOTO        L_main233
;Voodoo_V1.c,988 :: 		for (i = reject_blk + 1; i <= blk_limit; i++) {
	MOVF        _reject_blk+0, 0 
	ADDLW       1
	MOVWF       _i+0 
	CLRF        _i+1 
	MOVLW       0
	ADDWFC      _i+1, 1 
L_main234:
	MOVF        _i+1, 0 
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main334
	MOVF        _i+0, 0 
	SUBLW       7
L__main334:
	BTFSS       STATUS+0, 0 
	GOTO        L_main235
;Voodoo_V1.c,989 :: 		Lcd_Chr(2, 8 - i, 32);         // Fill rest of ferrous display with spaces
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVF        _i+0, 0 
	SUBLW       8
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       32
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;Voodoo_V1.c,988 :: 		for (i = reject_blk + 1; i <= blk_limit; i++) {
	INFSNZ      _i+0, 1 
	INCF        _i+1, 1 
;Voodoo_V1.c,990 :: 		}
	GOTO        L_main234
L_main235:
;Voodoo_V1.c,991 :: 		}
L_main233:
;Voodoo_V1.c,992 :: 		} else {
	GOTO        L_main237
L_main229:
;Voodoo_V1.c,993 :: 		Lcd_Chr(2, 7, 32);                 // Clear first block in ferrous display
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       7
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       32
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;Voodoo_V1.c,994 :: 		}
L_main237:
;Voodoo_V1.c,995 :: 		}
L_main228:
;Voodoo_V1.c,996 :: 		update_disp = 0;                       // Reset update display flag
	CLRF        _update_disp+0 
;Voodoo_V1.c,997 :: 		}
L_main219:
;Voodoo_V1.c,998 :: 		keypad_btn = scan_keypad();
	CALL        _scan_keypad+0, 0
	MOVF        R0, 0 
	MOVWF       _keypad_btn+0 
;Voodoo_V1.c,999 :: 		if (keypad_btn == menu_btn) {            // Check if menu button pressed
	MOVLW       0
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__main335
	MOVLW       1
	XORWF       R0, 0 
L__main335:
	BTFSS       STATUS+0, 2 
	GOTO        L_main238
;Voodoo_V1.c,1000 :: 		menu_system();                         // Enter menu system
	CALL        _menu_system+0, 0
;Voodoo_V1.c,1001 :: 		disp_reset();                          // Reset display after exiting menu system
	CALL        _disp_reset+0, 0
;Voodoo_V1.c,1002 :: 		}
L_main238:
;Voodoo_V1.c,1003 :: 		loop_count++;                            // Increment loop count
	INCF        _loop_count+0, 1 
;Voodoo_V1.c,1004 :: 		main_state = (loop_count == 128)?1:0;    // Read battery voltage after loop count of 128
	MOVF        _loop_count+0, 0 
	XORLW       128
	BTFSS       STATUS+0, 2 
	GOTO        L_main239
	MOVLW       1
	MOVWF       ?FLOC___mainT363+0 
	GOTO        L_main240
L_main239:
	CLRF        ?FLOC___mainT363+0 
L_main240:
	MOVF        ?FLOC___mainT363+0, 0 
	MOVWF       _main_state+0 
;Voodoo_V1.c,1005 :: 		break;
	GOTO        L_main183
;Voodoo_V1.c,1006 :: 		case 1:
L_main241:
;Voodoo_V1.c,1007 :: 		battery_measure();                       // Acquire battery voltage
	CALL        _battery_measure+0, 0
;Voodoo_V1.c,1008 :: 		battery_display();                       // Display battery voltage
	CALL        _battery_display+0, 0
;Voodoo_V1.c,1009 :: 		battery_symbol();                        // Display appropriate battery symbol
	CALL        _battery_symbol+0, 0
;Voodoo_V1.c,1010 :: 		loop_count = 0;                          // Reset loop count
	CLRF        _loop_count+0 
;Voodoo_V1.c,1011 :: 		main_state = 0;                          // Reset main program state machine
	CLRF        _main_state+0 
;Voodoo_V1.c,1012 :: 		break;
	GOTO        L_main183
;Voodoo_V1.c,1013 :: 		}
L_main182:
	MOVF        _main_state+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_main184
	MOVF        _main_state+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_main241
L_main183:
;Voodoo_V1.c,1014 :: 		}
	GOTO        L_main180
;Voodoo_V1.c,1015 :: 		}
L_end_main:
	GOTO        $+0
; end of _main
